# emacs-mode: -*- python-*-
import xml.dom.minidom
from Utilidades import Utilidades
class Instalacion:
    __module__ = __name__

    def __init__(self):
        self.nombreFichero = ''
        self.nombre = ''
        self.domicilio = ''
        self.provincia = ''
        self.localidad = ''
        self.codigoPostal = ''
        self.dni = ''
        self.mail = ''
        self.telefono = ''
        self.idTitular = 0
        self.nombreRepresentante = ''
        self.correoRepresentante = ''
        self.dniRepresentante = ''
        self.Rnombre = ''
        self.Rdomicilio = ''
        self.Rprovincia = ''
        self.Rlocalidad = ''
        self.RcodigoPostal = ''
        self.Rdni = ''
        self.Rmail = ''
        self.Rtelefono = ''
        self.RCarne = ''
        self.RCategoria = ''
        self.RIngeniero = -1
        self.RRegistro = ''
        self.idRedactor = 0
        self.REmpresa = ''
        self.RnombreRepresentante = ''
        self.RcorreoRepresentante = ''
        self.RdniRepresentante = ''
        self.IEmplazamiento = ''
        self.Iprovincia = ''
        self.Ilocalidad = ''
        self.IcodigoPostal = ''
        self.IUso = ''
        self.ISuperficie = 0.0
        self.IOcupacion = 0
        self.ITipo = ''
        self.IProyecto = -1
        self.IInstalacion = -1
        self.IDensidad = 0.0
        self.IActividad = ''
        self.IfechaDesde = '  /  /    '
        self.IfechaHasta = '  /  /    '
        self.receptoresAlumbrado = []
        self.receptoresFuerza = []
        self.electrificacion = -1
        self.tarifaNocturna = -1
        self.climatizacion = -1
        self.prevision = 0
        self.NumeroPlanta = 0
        self.NumeroViviendas = 0
        self.NumeroLocales = 0
        self.NumeroOtros = 0
        self.EClimatizacion = -1
        self.ETarifaNocturna = -1
        self.previsionViviendas = []
        self.totalPrevisionViviendas = 0
        self.previsionLocales = []
        self.totalPrevisionLocales = 0
        self.previsionServiciosGenerales = []
        array = ['',
         0,
         0,
         0,
         0]
        for i in range(8):
            self.previsionServiciosGenerales.append(array)

        self.totalPrevisionServicios = 0
        self.totalPotenciaContratar = 0
        self.potenciaAmpliacion = []
        self.viviendasSin = 0
        self.viviendasCon = 0
        self.locales = 0
        self.servicios = 0
        self.listaCheck = [0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0]
        self.empresa = ''
        self.puntoConexion = ''
        self.intensidadCC = 0
        self.tipoSuministro = -1
        self.tensionSuministro = ''
        self.potenciaInstalada = 0
        self.contadorInstalacion = -1
        self.poderCorte = 0
        self.proteccionSobreTensiones = ''
        self.proteccionCategoria = ''
        self.checkInterruptor = 0
        self.checkFusible = 0
        self.interruptorGeneral = 0
        self.aclaracion = ''
        self.calculosJustificativos = []
        self.imagenesCroquis = []
        self.textoCroquis = ''
        self.inBase1 = 0
        self.inBase2 = 0
        self.inFusible1 = 0
        self.inFusible2 = 0
        self.inPotencia1 = 0
        self.inPotencia2 = 0
        self.tomaTierra = ''
        self.conductores = ''
        self.resistenciaCalculada = 0
        self.resistenciaTierra = 0
        self.resistenciaAislamiento = 0
        self.documentos = [0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0]
        self.otrosDocumentos = ''
        self.solicitud = 0
        self.datosRegistro = [0,
         0]
        self.numeroRegistro = ''
        self.otrasInstalaciones = [0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0]
        self.otrasInstalacionesTexto = ''
        self.instalacionLGA = ''
        self.conductorLGA = ''
        self.seccionLGA = ''
        self.materialLGA = ''
        self.potenciaLGA = 0
        self.instalacionDI = ''
        self.conductorDI = ''
        self.seccionDI = ''
        self.materialDI = ''
        self.tensionDI = 0
        self.intensidadDI = 0
        self.interruptorDI = 0
        self.potenciaDI = 0
        self.sensibilidadesProyecto = [0,
         0,
         0,
         0]
        self.otraSensibilidad = ''
        self.numeroOCA = ''
        self.referenciaOCA = ''
        self.fechaOCA = '  /  /    '
        self.fechaBajaTension = '  /  /    '
        self.lugar = ''
        self.fechaFirma = '  /  /    '



    def __cmp__(self, otro):
        if (otro.__dict__ == self.__dict__):
            return 0
        else:
            return 1

    def esEditable(self,paso):
	if self.ITipo == "": return 0
	if self.ITipo[0] == "f":
	  if self.IInstalacion == -1: return 0 
	  if self.IInstalacion == 0: 
	    if paso[:2] in ("41","43","44"): return 0
	    elif paso[:2] == "42": return 1
	    elif paso[:1] in ("6","7","8","9"): return not(self.compruebaProyecto())
	    elif paso[:2] == "10": return self.compruebaProyecto()
	elif self.ITipo[0] == "e":
	  if self.IInstalacion == -1: return 0
	  if self.IInstalacion == 0:
	    if paso[:2] in ("41","42","44"): return 0
	    elif paso[:2] == "43": return 1
	    elif paso[:1] in ("6","7","8","9"): return not(self.compruebaProyecto())
	    elif paso[:2] == "10": return self.compruebaProyecto()
	  if self.IInstalacion == 1:
	    if paso[:2] in ("41","42","43"): return 0
	    elif paso[:2] == "44": return 1
	    elif paso[:1] in ("6","7","8","9"): return not(self.compruebaProyecto())
	    elif paso[:2] == "10": return self.compruebaProyecto()
	if paso[:2] in ("42","43","44"): return 0
	elif paso[:2] == "41": return 1
	elif paso[:1] in ("6","7","8","9"): return not(self.compruebaProyecto())
	elif paso[:2] == "10": return self.compruebaProyecto()
	return 1
	    



    def guardaFichero(self, nombreFichero):
        self.guardaTitulares()
        self.guardaRedactores()
        util = Utilidades()
        self.datosXML = xml.dom.minidom.parseString("<?xml version='1.0' encoding='iso-8859-15'?><Instalacion></Instalacion>")
        instalacion = self.datosXML.childNodes[0]
        instalacion.setAttribute('Nombre', util.convierteCadenaUNICODE(self.nombre))
        instalacion.setAttribute('Domicilio', util.convierteCadenaUNICODE(self.domicilio))
        instalacion.setAttribute('Provincia', util.convierteCadenaUNICODE(self.provincia))
        instalacion.setAttribute('Localidad', util.convierteCadenaUNICODE(self.localidad))
        instalacion.setAttribute('CodigoPostal', util.convierteCadenaUNICODE(self.codigoPostal))
        instalacion.setAttribute('DNI', util.convierteCadenaUNICODE(self.dni))
        instalacion.setAttribute('Mail', util.convierteCadenaUNICODE(self.mail))
        instalacion.setAttribute('Telefono', util.convierteCadenaUNICODE(self.telefono))
        instalacion.setAttribute('IdTitular', util.convierteCadenaUNICODE(str(self.idTitular)))
        instalacion.setAttribute('NombreRepresentante', util.convierteCadenaUNICODE(self.nombreRepresentante))
        instalacion.setAttribute('CorreoRepresentante', util.convierteCadenaUNICODE(self.correoRepresentante))
        instalacion.setAttribute('DniRepresentante', util.convierteCadenaUNICODE(self.dniRepresentante))
        instalacion.setAttribute('IdRedactor', util.convierteCadenaUNICODE(str(self.idRedactor)))
        instalacion.setAttribute('RNombre', util.convierteCadenaUNICODE(self.Rnombre))
        instalacion.setAttribute('RDomicilio', util.convierteCadenaUNICODE(self.Rdomicilio))
        instalacion.setAttribute('RProvincia', util.convierteCadenaUNICODE(self.Rprovincia))
        instalacion.setAttribute('RLocalidad', util.convierteCadenaUNICODE(self.Rlocalidad))
        instalacion.setAttribute('RRegistro', util.convierteCadenaUNICODE(self.RRegistro))
        instalacion.setAttribute('PCodigoPostal', util.convierteCadenaUNICODE(self.RcodigoPostal))
        instalacion.setAttribute('RDNI', util.convierteCadenaUNICODE(self.Rdni))
        instalacion.setAttribute('Rmail', util.convierteCadenaUNICODE(self.Rmail))
        instalacion.setAttribute('RTelefono', util.convierteCadenaUNICODE(self.Rtelefono))
        instalacion.setAttribute('RCarne', util.convierteCadenaUNICODE(self.RCarne))
        instalacion.setAttribute('RCategoria', util.convierteCadenaUNICODE(self.RCategoria))
        instalacion.setAttribute('RIngeniero', util.convierteCadenaUNICODE(str(self.RIngeniero)))
        instalacion.setAttribute('REmpresa', util.convierteCadenaUNICODE(self.REmpresa))
        instalacion.setAttribute('RNombreRepresentante', util.convierteCadenaUNICODE(self.RnombreRepresentante))
        instalacion.setAttribute('RCorreoRepresentante', util.convierteCadenaUNICODE(self.RcorreoRepresentante))
        instalacion.setAttribute('RDniRepresentante', util.convierteCadenaUNICODE(self.RdniRepresentante))
        instalacion.setAttribute('IEmplazamiento', util.convierteCadenaUNICODE(self.IEmplazamiento))
        instalacion.setAttribute('IProvincia', util.convierteCadenaUNICODE(self.Iprovincia))
        instalacion.setAttribute('ILocalidad', util.convierteCadenaUNICODE(self.Ilocalidad))
        instalacion.setAttribute('ICodigoPostal', util.convierteCadenaUNICODE(self.IcodigoPostal))
        instalacion.setAttribute('IUso', util.convierteCadenaUNICODE(self.IUso))
        instalacion.setAttribute('ISuperficie', util.convierteCadenaUNICODE(str(self.ISuperficie)))
        instalacion.setAttribute('IOcupacion', util.convierteCadenaUNICODE(str(self.IOcupacion)))
        instalacion.setAttribute('ITipo', util.convierteCadenaUNICODE(self.ITipo))
        instalacion.setAttribute('IProyecto', util.convierteCadenaUNICODE(str(self.IProyecto)))
        instalacion.setAttribute('IActividad', util.convierteCadenaUNICODE(self.IActividad))
        instalacion.setAttribute('IDensidad', util.convierteCadenaUNICODE(str(self.IDensidad)))
        instalacion.setAttribute('IInstalacion', util.convierteCadenaUNICODE(str(self.IInstalacion)))
        instalacion.setAttribute('IFechaDesde', util.convierteCadenaUNICODE(self.IfechaDesde))
        instalacion.setAttribute('IFechaHasta', util.convierteCadenaUNICODE(self.IfechaHasta))
        instalacion.setAttribute('Electrificacion', util.convierteCadenaUNICODE(str(self.electrificacion)))
        instalacion.setAttribute('TarifaNocturna', util.convierteCadenaUNICODE(str(self.tarifaNocturna)))
        instalacion.setAttribute('Climatizacion', util.convierteCadenaUNICODE(str(self.climatizacion)))
        instalacion.setAttribute('Prevision', util.convierteCadenaUNICODE(str(self.prevision)))
        instalacion.setAttribute('NumeroPlanta', util.convierteCadenaUNICODE(str(self.NumeroPlanta)))
        instalacion.setAttribute('NumeroViviendas', util.convierteCadenaUNICODE(str(self.NumeroViviendas)))
        instalacion.setAttribute('NumeroLocales', util.convierteCadenaUNICODE(str(self.NumeroLocales)))
        instalacion.setAttribute('NumeroOtros', util.convierteCadenaUNICODE(str(self.NumeroOtros)))
        instalacion.setAttribute('EClimatizacion', util.convierteCadenaUNICODE(str(self.EClimatizacion)))
        instalacion.setAttribute('ETarifaNocturna', util.convierteCadenaUNICODE(str(self.ETarifaNocturna)))
        instalacion.setAttribute('TotalPrevisionViviendas', util.convierteCadenaUNICODE(str(self.totalPrevisionViviendas)))
        instalacion.setAttribute('TotalPrevisionLocales', util.convierteCadenaUNICODE(str(self.totalPrevisionLocales)))
        instalacion.setAttribute('TotalPrevisionServicios', util.convierteCadenaUNICODE(str(self.totalPrevisionServicios)))
        instalacion.setAttribute('ViviendasSin', util.convierteCadenaUNICODE(str(self.viviendasSin)))
        instalacion.setAttribute('ViviendasCon', util.convierteCadenaUNICODE(str(self.viviendasCon)))
        instalacion.setAttribute('Locales', util.convierteCadenaUNICODE(str(self.locales)))
        instalacion.setAttribute('Servicios', util.convierteCadenaUNICODE(str(self.servicios)))
        instalacion.setAttribute('Empresa', util.convierteCadenaUNICODE(self.empresa))
        instalacion.setAttribute('Conexion', util.convierteCadenaUNICODE(self.puntoConexion))
        instalacion.setAttribute('IntensidadCC', util.convierteCadenaUNICODE(str(self.intensidadCC)))
        instalacion.setAttribute('TipoSuministro', util.convierteCadenaUNICODE(str(self.tipoSuministro)))
        instalacion.setAttribute('TensionSuministro', util.convierteCadenaUNICODE(str(self.tensionSuministro)))
        instalacion.setAttribute('PotenciaInstalada', util.convierteCadenaUNICODE(str(self.potenciaInstalada)))
        instalacion.setAttribute('ContadorInstalacion', util.convierteCadenaUNICODE(str(self.contadorInstalacion)))
        instalacion.setAttribute('PoderDeCorte', util.convierteCadenaUNICODE(str(self.poderCorte)))
        instalacion.setAttribute('ProteccionSobreTensiones', util.convierteCadenaUNICODE(self.proteccionSobreTensiones))
        instalacion.setAttribute('ProteccionCategoria', util.convierteCadenaUNICODE(self.proteccionCategoria))
        instalacion.setAttribute('CheckInterruptor', util.convierteCadenaUNICODE(str(self.checkInterruptor)))
        instalacion.setAttribute('CheckFusible', util.convierteCadenaUNICODE(str(self.checkFusible)))
        instalacion.setAttribute('InterruptorGeneral', util.convierteCadenaUNICODE(str(self.interruptorGeneral)))
        instalacion.setAttribute('PotenciaContratar', util.convierteCadenaUNICODE(str(self.totalPotenciaContratar)))
        instalacion.setAttribute('InBase1', util.convierteCadenaUNICODE(str(self.inBase1)))
        instalacion.setAttribute('InBase2', util.convierteCadenaUNICODE(str(self.inBase2)))
        instalacion.setAttribute('InFusible1', util.convierteCadenaUNICODE(str(self.inFusible1)))
        instalacion.setAttribute('InFusible2', util.convierteCadenaUNICODE(str(self.inFusible2)))
        instalacion.setAttribute('InPotencia1', util.convierteCadenaUNICODE(str(self.inPotencia1)))
        instalacion.setAttribute('InPotencia2', util.convierteCadenaUNICODE(str(self.inPotencia2)))
        instalacion.setAttribute('TomaTierra', util.convierteCadenaUNICODE(self.tomaTierra))
        instalacion.setAttribute('Conductores', util.convierteCadenaUNICODE(self.conductores))
        instalacion.setAttribute('ResistenciaCalculada', util.convierteCadenaUNICODE(str(self.resistenciaCalculada)))
        instalacion.setAttribute('ResistenciaTierra', util.convierteCadenaUNICODE(str(self.resistenciaTierra)))
        instalacion.setAttribute('ResistenciaAislamiento', util.convierteCadenaUNICODE(str(self.resistenciaAislamiento)))
        instalacion.setAttribute('Solicitud', util.convierteCadenaUNICODE(str(self.solicitud)))
        instalacion.setAttribute('FechaBajaTension', util.convierteCadenaUNICODE(str(self.fechaBajaTension)))
        instalacion.setAttribute('Lugar', util.convierteCadenaUNICODE(str(self.lugar)))
        instalacion.setAttribute('FechaFirma', util.convierteCadenaUNICODE(str(self.fechaFirma)))
        instalacion.setAttribute('OtrasDocumentaciones', util.convierteCadenaUNICODE(self.otrosDocumentos))
        instalacion.setAttribute('OtrasInstalaciones', util.convierteCadenaUNICODE(self.otrasInstalacionesTexto))
        instalacion.setAttribute('NumeroRegistro', util.convierteCadenaUNICODE(self.numeroRegistro))
        instalacion.setAttribute('InstalacionLGA', util.convierteCadenaUNICODE(self.instalacionLGA))
        instalacion.setAttribute('ConductorLGA', util.convierteCadenaUNICODE(self.conductorLGA))
        instalacion.setAttribute('SeccionLGA', util.convierteCadenaUNICODE(self.seccionLGA))
        instalacion.setAttribute('MaterialLGA', util.convierteCadenaUNICODE(self.materialLGA))
        instalacion.setAttribute('PotenciaLGA', util.convierteCadenaUNICODE(str(self.potenciaLGA)))
        instalacion.setAttribute('InstalacionDI', util.convierteCadenaUNICODE(self.instalacionDI))
        instalacion.setAttribute('ConductorDI', util.convierteCadenaUNICODE(self.conductorDI))
        instalacion.setAttribute('SeccionDI', util.convierteCadenaUNICODE(self.seccionDI))
        instalacion.setAttribute('MaterialDI', util.convierteCadenaUNICODE(self.materialDI))
        instalacion.setAttribute('TensionDI', util.convierteCadenaUNICODE(str(self.tensionDI)))
        instalacion.setAttribute('IntensidadDI', util.convierteCadenaUNICODE(str(self.intensidadDI)))
        instalacion.setAttribute('InterruptorDI', util.convierteCadenaUNICODE(str(self.interruptorDI)))
        instalacion.setAttribute('PotenciaDI', util.convierteCadenaUNICODE(str(self.potenciaDI)))
        instalacion.setAttribute('OtraSensibilidad', util.convierteCadenaUNICODE(self.otraSensibilidad))
        instalacion.setAttribute('NumeroOCA', util.convierteCadenaUNICODE(self.numeroOCA))
        instalacion.setAttribute('ReferenciaOCA', util.convierteCadenaUNICODE(self.referenciaOCA))
        instalacion.setAttribute('FechaOCA', util.convierteCadenaUNICODE(self.fechaOCA))
        instalacion.appendChild(self.dameHijoReceptoresAlumbrado())
        instalacion.appendChild(self.dameHijoReceptoresFuerza())
        instalacion.appendChild(self.dameHijoPrevisionViviendas())
        instalacion.appendChild(self.dameHijoPrevisionLocales())
        instalacion.appendChild(self.dameHijoPrevisionServicios())
        instalacion.appendChild(self.dameHijoPotenciaAmpliacion())
        instalacion.appendChild(self.dameHijoListaCheck())
        instalacion.appendChild(self.dameHijoCalculosJustificativos())
        instalacion.appendChild(self.dameHijoDocumentos())
        instalacion.appendChild(self.dameHijoDatosRegistro())
        instalacion.appendChild(self.dameHijoOtrasInstalaciones())
        instalacion.appendChild(self.dameHijoOtrasSensibilidades())
        instalacion.appendChild(self.dameHijoAclaracion())
        instalacion.appendChild(self.dameHijoTextoCroquis())
        instalacion.appendChild(self.dameHijoImagenesCroquis())
        f = open(nombreFichero, 'w')
        cadena = self.datosXML.toxml('iso-8859-15')
        f.write(cadena)
        f.close()
        self.datosXML.unlink()



    def dameHijoImagenesCroquis(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('ImagenesCroquis')
        for receptor in self.imagenesCroquis:
            nodoReceptor = self.datosXML.createElement('Imagen')
            nodoReceptor.setAttribute('ruta', util.convierteCadenaUNICODE(receptor))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoAclaracion(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('Aclaracion')
        nodoCDATA = self.datosXML.createCDATASection(util.convierteCadenaUNICODE(self.aclaracion))
        nodo.appendChild(nodoCDATA)
        return nodo



    def dameHijoTextoCroquis(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('TextoCroquis')
        nodoCDATA = self.datosXML.createCDATASection(util.convierteCadenaUNICODE(self.textoCroquis))
        nodo.appendChild(nodoCDATA)
        return nodo



    def dameHijoReceptoresAlumbrado(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('ReceptoresAlumbrado')
        for receptor in self.receptoresAlumbrado:
            nodoReceptor = self.datosXML.createElement('ReceptorAlumbrado')
            nodoReceptor.setAttribute('Unidades', util.convierteCadenaUNICODE(receptor[0]))
            nodoReceptor.setAttribute('Receptor', util.convierteCadenaUNICODE(receptor[1]))
            nodoReceptor.setAttribute('Potencia', util.convierteCadenaUNICODE(receptor[2]))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoReceptoresFuerza(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('ReceptoresFuerza')
        for receptor in self.receptoresFuerza:
            nodoReceptor = self.datosXML.createElement('ReceptorFuerza')
            nodoReceptor.setAttribute('Unidades', util.convierteCadenaUNICODE(receptor[0]))
            nodoReceptor.setAttribute('Receptor', util.convierteCadenaUNICODE(receptor[1]))
            nodoReceptor.setAttribute('Potencia', util.convierteCadenaUNICODE(receptor[2]))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoPrevisionViviendas(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('PrevisionViviendas')
        for receptor in self.previsionViviendas:
            nodoReceptor = self.datosXML.createElement('PrevisionVivienda')
            nodoReceptor.setAttribute('Unidades', util.convierteCadenaUNICODE(receptor[0]))
            nodoReceptor.setAttribute('Superficie', util.convierteCadenaUNICODE(str(receptor[1])))
            nodoReceptor.setAttribute('Tarifa', util.convierteCadenaUNICODE(receptor[2]))
            nodoReceptor.setAttribute('Electrificacion', util.convierteCadenaUNICODE(receptor[3]))
            nodoReceptor.setAttribute('Potencia', util.convierteCadenaUNICODE(receptor[4]))
            nodoReceptor.setAttribute('Total', util.convierteCadenaUNICODE(receptor[5]))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoPrevisionLocales(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('PrevisionLocales')
        for receptor in self.previsionLocales:
            nodoReceptor = self.datosXML.createElement('PrevisionLocal')
            nodoReceptor.setAttribute('Unidades', util.convierteCadenaUNICODE(receptor[0]))
            nodoReceptor.setAttribute('Superficie', util.convierteCadenaUNICODE(str(receptor[1])))
            nodoReceptor.setAttribute('CargaPrevista', util.convierteCadenaUNICODE(receptor[2]))
            nodoReceptor.setAttribute('Total', util.convierteCadenaUNICODE(receptor[3]))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoPrevisionServicios(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('PrevisionServicios')
        for receptor in self.previsionServiciosGenerales:
            nodoReceptor = self.datosXML.createElement('PrevisionServicio')
            nodoReceptor.setAttribute('Nombre', util.convierteCadenaUNICODE(receptor[0]))
            nodoReceptor.setAttribute('Dato1', util.convierteCadenaUNICODE(str(receptor[1])))
            try:
                nodoReceptor.setAttribute('Dato2', util.convierteCadenaUNICODE(str(receptor[2])))
                nodoReceptor.setAttribute('Dato3', util.convierteCadenaUNICODE(str(receptor[3])))
                nodoReceptor.setAttribute('Dato4', util.convierteCadenaUNICODE(str(receptor[4])))
                nodoReceptor.setAttribute('Dato5', util.convierteCadenaUNICODE(str(receptor[5])))
            except:
                pass
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoPotenciaAmpliacion(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('PotenciaAmpliacion')
        for receptor in self.potenciaAmpliacion:
            nodoReceptor = self.datosXML.createElement('Potencia')
            nodoReceptor.setAttribute('Identificacion', util.convierteCadenaUNICODE(receptor[0]))
            nodoReceptor.setAttribute('Superficie', util.convierteCadenaUNICODE(receptor[1]))
            nodoReceptor.setAttribute('Tarifa', util.convierteCadenaUNICODE(receptor[2]))
            nodoReceptor.setAttribute('Electrificacion', util.convierteCadenaUNICODE(receptor[3]))
            nodoReceptor.setAttribute('APotencia', util.convierteCadenaUNICODE(receptor[4]))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoListaCheck(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('ListaCheck')
        for receptor in self.listaCheck:
            nodoReceptor = self.datosXML.createElement('Check')
            nodoReceptor.setAttribute('Valor', util.convierteCadenaUNICODE(str(receptor)))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoCalculosJustificativos(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('Calculos')
        for datoHoja in self.calculosJustificativos:
            nodoReceptor = self.datosXML.createElement('CalculoJustificativos')
            nodoReceptor.setAttribute('observaciones', util.convierteCadenaUNICODE(datoHoja.observaciones))
            nodoReceptor.setAttribute('numDiferenciales', util.convierteCadenaUNICODE(str(datoHoja.numDiferenciales)))
            nodoReceptor.setAttribute('eAplicacion', util.convierteCadenaUNICODE(str(datoHoja.esquemaAplicacion)))
            nodoReceptor.setAttribute('eAdjunto', util.convierteCadenaUNICODE(str(datoHoja.esquemaAdjunto)))
            nodoReceptor.setAttribute('fEsquema', util.convierteCadenaUNICODE(datoHoja.ficheroEsquema))
            nodoReceptor.setAttribute('fAplicacion', util.convierteCadenaUNICODE(datoHoja.ficheroEsquemaAplicacion))
            for dato in datoHoja.datosCircuitos:
                nodoDato = self.datosXML.createElement('Datos')
                nodoDato.setAttribute('linea', util.convierteCadenaUNICODE(str(dato.linea)))
                nodoDato.setAttribute('numeroCircuito', util.convierteCadenaUNICODE(str(dato.numeroCircuito)))
                nodoDato.setAttribute('fuerza', util.convierteCadenaUNICODE(str(dato.fuerza)))
                nodoDato.setAttribute('LDenominacionLinea', util.convierteCadenaUNICODE(dato.LDenominacionLinea))
                nodoDato.setAttribute('fase', util.convierteCadenaUNICODE(str(dato.fase)))
                nodoDato.setAttribute('LFase', util.convierteCadenaUNICODE(dato.LFase))
                nodoDato.setAttribute('comboTension', util.convierteCadenaUNICODE(str(dato.comboTension)))
                nodoDato.setAttribute('tension', util.convierteCadenaUNICODE(str(dato.tension)))
                nodoDato.setAttribute('LTension', util.convierteCadenaUNICODE(dato.LTension))
                nodoDato.setAttribute('potencia', util.convierteCadenaUNICODE(str(dato.potencia)))
                nodoDato.setAttribute('LPotencia', util.convierteCadenaUNICODE(dato.LPotencia))
                nodoDato.setAttribute('aislamiento', util.convierteCadenaUNICODE(str(dato.aislamiento)))
                nodoDato.setAttribute('comboTensionDI', util.convierteCadenaUNICODE(str(dato.comboTensionDI)))
                nodoDato.setAttribute('tensionDI', util.convierteCadenaUNICODE(dato.tensionDI))
                nodoDato.setAttribute('tipoInstalacion', util.convierteCadenaUNICODE(str(dato.tipoInstalacion)))
                nodoDato.setAttribute('coeficienteCalculo', util.convierteCadenaUNICODE(str(dato.coeficienteCalculo)))
                nodoDato.setAttribute('LCoeficienteCalculo', util.convierteCadenaUNICODE(dato.LCoeficienteCalculo))
                nodoDato.setAttribute('LPotenciaCalculo', util.convierteCadenaUNICODE(dato.LPotenciaCalculo))
                nodoDato.setAttribute('longitud', util.convierteCadenaUNICODE(str(dato.longitud)))
                nodoDato.setAttribute('LLongitud', util.convierteCadenaUNICODE(dato.LLongitud))
                nodoDato.setAttribute('factorPotencia', util.convierteCadenaUNICODE(str(dato.factorPotencia)))
                nodoDato.setAttribute('material', util.convierteCadenaUNICODE(str(dato.material)))
                nodoDato.setAttribute('LIntensidad', util.convierteCadenaUNICODE(dato.LIntensidad))
                nodoDato.setAttribute('factorCorreccion', util.convierteCadenaUNICODE(str(dato.factorCorreccion)))
                nodoDato.setAttribute('naturaleza', util.convierteCadenaUNICODE(str(dato.naturaleza)))
                nodoDato.setAttribute('LSeccion', util.convierteCadenaUNICODE(dato.LSeccion))
                nodoDato.setAttribute('LCaidaTension', util.convierteCadenaUNICODE(dato.LCaidaTension))
                nodoDato.setAttribute('LCaidaTensionAdmisible', util.convierteCadenaUNICODE(dato.LCaidaTensionAdmisible))
                nodoDato.setAttribute('LDensidad', util.convierteCadenaUNICODE(dato.LDensidad))
                nodoDato.setAttribute('canalizacion', util.convierteCadenaUNICODE(str(dato.canalizacion)))
                nodoDato.setAttribute('LCanalizacion', util.convierteCadenaUNICODE(dato.LCanalizacion))
                nodoDato.setAttribute('sensibilidadCombo', util.convierteCadenaUNICODE(str(dato.sensibilidadCombo)))
                nodoDato.setAttribute('sensibilidadNumero', util.convierteCadenaUNICODE(str(dato.sensibilidadNumero)))
                nodoDato.setAttribute('LSensibilidad', util.convierteCadenaUNICODE(dato.LSensibilidad))
                nodoDato.setAttribute('intensidadAdmisible', util.convierteCadenaUNICODE(str(dato.intensidadAdmisible)))
                nodoDato.setAttribute('LProteccionSobre', util.convierteCadenaUNICODE(dato.LProteccionSobre))
                nodoReceptor.appendChild(nodoDato)

            if (not (datoHoja.esquema == '')):
                nodoEsquema = self.datosXML.createElement('Esquema')
                nodoEsquema.setAttribute('proteccion', util.convierteCadenaUNICODE(str(datoHoja.esquema.protecciones)))
                for diferencial in datoHoja.esquema.diferenciales:
                    nodoDiferencial = self.datosXML.createElement('Diferencial')
                    nodoDiferencial.setAttribute('nombre', util.convierteCadenaUNICODE(diferencial.nombre))
                    nodoDiferencial.setAttribute('proteccion', util.convierteCadenaUNICODE(str(diferencial.minimaProteccion)))
                    nodoDiferencial.setAttribute('sensibilidad', util.convierteCadenaUNICODE(str(diferencial.sensibilidad)))
                    nodoDiferencial.setAttribute('polos', util.convierteCadenaUNICODE(diferencial.polos))
                    nodoDiferencial.setAttribute('poloSeleccionado', util.convierteCadenaUNICODE(str(diferencial.poloSeleccionado)))
                    for circuito in diferencial.circuitos:
                        nodoCircuito = self.datosXML.createElement('CircuitoEsquema')
                        nodoCircuito.setAttribute('nombre', util.convierteCadenaUNICODE(circuito.nombre))
                        nodoCircuito.setAttribute('descripcion', util.convierteCadenaUNICODE(circuito.descripcion))
                        nodoCircuito.setAttribute('polos', util.convierteCadenaUNICODE(circuito.polos))
                        nodoCircuito.setAttribute('diferencial', util.convierteCadenaUNICODE(circuito.diferencial))
                        nodoCircuito.setAttribute('nombreDato', util.convierteCadenaUNICODE(circuito.datos.LDenominacionLinea))
                        nodoDiferencial.appendChild(nodoCircuito)

                    nodoEsquema.appendChild(nodoDiferencial)

                nodoReceptor.appendChild(nodoEsquema)
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoDocumentos(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('Documentos')
        for receptor in self.documentos:
            nodoReceptor = self.datosXML.createElement('Documentos')
            nodoReceptor.setAttribute('Valor', util.convierteCadenaUNICODE(str(receptor)))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoDatosRegistro(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('DatosRegistro')
        for receptor in self.datosRegistro:
            nodoReceptor = self.datosXML.createElement('Datos')
            nodoReceptor.setAttribute('Valor', util.convierteCadenaUNICODE(str(receptor)))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoOtrasInstalaciones(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('OtrasInstalaciones')
        for receptor in self.otrasInstalaciones:
            nodoReceptor = self.datosXML.createElement('OtraInstalacion')
            nodoReceptor.setAttribute('Valor', util.convierteCadenaUNICODE(str(receptor)))
            nodo.appendChild(nodoReceptor)

        return nodo



    def dameHijoOtrasSensibilidades(self):
        util = Utilidades()
        nodo = self.datosXML.createElement('OtrasSensibilidades')
        for receptor in self.sensibilidadesProyecto:
            nodoReceptor = self.datosXML.createElement('OtraSensibilidad')
            nodoReceptor.setAttribute('Valor', util.convierteCadenaUNICODE(str(receptor)))
            nodo.appendChild(nodoReceptor)

        return nodo



    def abreFichero(self, nombreFichero):
        util = Utilidades()
        self.datosXML = xml.dom.minidom.parse(nombreFichero)
        instalacion = self.datosXML.childNodes[0]
        self.nombre = util.convierteCadenaISO(instalacion.getAttribute('Nombre'))
        self.domicilio = util.convierteCadenaISO(instalacion.getAttribute('Domicilio'))
        self.provincia = util.convierteCadenaISO(instalacion.getAttribute('Provincia'))
        self.localidad = util.convierteCadenaISO(instalacion.getAttribute('Localidad'))
        self.codigoPostal = util.convierteCadenaISO(instalacion.getAttribute('CodigoPostal'))
        self.dni = util.convierteCadenaISO(instalacion.getAttribute('DNI'))
        self.mail = util.convierteCadenaISO(instalacion.getAttribute('Mail'))
        self.telefono = util.convierteCadenaISO(instalacion.getAttribute('Telefono'))
        self.idTitular = util.convierteCadenaISO(instalacion.getAttribute('IdTitular'))
        self.nombreRepresentante = util.convierteCadenaISO(instalacion.getAttribute('NombreRepresentante'))
        self.correoRepresentante = util.convierteCadenaISO(instalacion.getAttribute('CorreoRepresentante'))
        self.dniRepresentante = util.convierteCadenaISO(instalacion.getAttribute('DniRepresentante'))
        self.Rnombre = util.convierteCadenaISO(instalacion.getAttribute('RNombre'))
        self.Rdomicilio = util.convierteCadenaISO(instalacion.getAttribute('RDomicilio'))
        self.Rprovincia = util.convierteCadenaISO(instalacion.getAttribute('RProvincia'))
        self.Rlocalidad = util.convierteCadenaISO(instalacion.getAttribute('RLocalidad'))
        self.RRegistro = util.convierteCadenaISO(instalacion.getAttribute('RRegistro'))
        self.RcodigoPostal = util.convierteCadenaISO(instalacion.getAttribute('PCodigoPostal'))
        self.Rdni = util.convierteCadenaISO(instalacion.getAttribute('RDNI'))
        self.Rmail = util.convierteCadenaISO(instalacion.getAttribute('Rmail'))
        self.Rtelefono = util.convierteCadenaISO(instalacion.getAttribute('RTelefono'))
        self.RCarne = util.convierteCadenaISO(instalacion.getAttribute('RCarne'))
        self.RCategoria = util.convierteCadenaISO(instalacion.getAttribute('RCategoria'))
        self.RIngeniero = int(util.convierteCadenaISO(instalacion.getAttribute('RIngeniero')))
        self.idRedactor = util.convierteCadenaISO(instalacion.getAttribute('IdRedactor'))
        self.REmpresa = util.convierteCadenaISO(instalacion.getAttribute('REmpresa'))
        self.RnombreRepresentante = util.convierteCadenaISO(instalacion.getAttribute('RNombreRepresentante'))
        self.RcorreoRepresentante = util.convierteCadenaISO(instalacion.getAttribute('RCorreoRepresentante'))
        self.RdniRepresentante = util.convierteCadenaISO(instalacion.getAttribute('RDniRepresentante'))
        self.IEmplazamiento = util.convierteCadenaISO(instalacion.getAttribute('IEmplazamiento'))
        self.Iprovincia = util.convierteCadenaISO(instalacion.getAttribute('IProvincia'))
        self.Ilocalidad = util.convierteCadenaISO(instalacion.getAttribute('ILocalidad'))
        self.IcodigoPostal = util.convierteCadenaISO(instalacion.getAttribute('ICodigoPostal'))
        self.IUso = util.convierteCadenaISO(instalacion.getAttribute('IUso'))
        self.ISuperficie = float(util.convierteCadenaISO(instalacion.getAttribute('ISuperficie')))
        self.IOcupacion = int(util.convierteCadenaISO(instalacion.getAttribute('IOcupacion')))
        self.IActividad = util.convierteCadenaISO(instalacion.getAttribute('IActividad'))
        self.IDensidad = float(util.convierteCadenaISO(instalacion.getAttribute('IDensidad')))
        self.ITipo = util.convierteCadenaISO(instalacion.getAttribute('ITipo'))
        self.IProyecto = int(util.convierteCadenaISO(instalacion.getAttribute('IProyecto')))
        self.IInstalacion = int(util.convierteCadenaISO(instalacion.getAttribute('IInstalacion')))
        self.IfechaDesde = util.convierteCadenaISO(instalacion.getAttribute('IFechaDesde'))
        self.IfechaHasta = util.convierteCadenaISO(instalacion.getAttribute('IFechaHasta'))
        self.electrificacion = int(util.convierteCadenaISO(instalacion.getAttribute('Electrificacion')))
        self.tarifaNocturna = int(util.convierteCadenaISO(instalacion.getAttribute('TarifaNocturna')))
        self.climatizacion = int(util.convierteCadenaISO(instalacion.getAttribute('Climatizacion')))
        self.prevision = float(util.convierteCadenaISO(instalacion.getAttribute('Prevision')))
        self.NumeroPlanta = int(util.convierteCadenaISO(instalacion.getAttribute('NumeroPlanta')))
        self.NumeroViviendas = int(util.convierteCadenaISO(instalacion.getAttribute('NumeroViviendas')))
        self.NumeroLocales = int(util.convierteCadenaISO(instalacion.getAttribute('NumeroLocales')))
        self.NumeroOtros = int(util.convierteCadenaISO(instalacion.getAttribute('NumeroOtros')))
        self.EClimatizacion = int(util.convierteCadenaISO(instalacion.getAttribute('EClimatizacion')))
        self.ETarifaNocturna = int(util.convierteCadenaISO(instalacion.getAttribute('ETarifaNocturna')))
        self.totalPrevisionViviendas = float(util.convierteCadenaISO(instalacion.getAttribute('TotalPrevisionViviendas')))
        self.totalPrevisionLocales = float(util.convierteCadenaISO(instalacion.getAttribute('TotalPrevisionLocales')))
        self.totalPrevisionServicios = float(util.convierteCadenaISO(instalacion.getAttribute('TotalPrevisionServicios')))
        self.viviendasSin = float(util.convierteCadenaISO(instalacion.getAttribute('ViviendasSin')))
        self.viviendasCon = float(util.convierteCadenaISO(instalacion.getAttribute('ViviendasCon')))
        self.locales = float(util.convierteCadenaISO(instalacion.getAttribute('Locales')))
        self.servicios = float(util.convierteCadenaISO(instalacion.getAttribute('Servicios')))
        self.empresa = util.convierteCadenaISO(instalacion.getAttribute('Empresa'))
        self.puntoConexion = util.convierteCadenaISO(instalacion.getAttribute('Conexion'))
        self.intensidadCC = float(util.convierteCadenaISO(instalacion.getAttribute('IntensidadCC')))
        self.tipoSuministro = int(util.convierteCadenaISO(instalacion.getAttribute('TipoSuministro')))
        self.tensionSuministro = util.convierteCadenaISO(instalacion.getAttribute('TensionSuministro'))
        self.potenciaInstalada = float(util.convierteCadenaISO(instalacion.getAttribute('PotenciaInstalada')))
        self.contadorInstalacion = int(util.convierteCadenaISO(instalacion.getAttribute('ContadorInstalacion')))
        self.poderCorte = float(util.convierteCadenaISO(instalacion.getAttribute('PoderDeCorte')))
        self.proteccionSobreTensiones = util.convierteCadenaISO(instalacion.getAttribute('ProteccionSobreTensiones'))
        self.proteccionCategoria = util.convierteCadenaISO(instalacion.getAttribute('ProteccionCategoria'))
        self.checkInterruptor = int(util.convierteCadenaISO(instalacion.getAttribute('CheckInterruptor')))
        self.checkFusible = int(util.convierteCadenaISO(instalacion.getAttribute('CheckFusible')))
        self.interruptorGeneral = float(util.convierteCadenaISO(instalacion.getAttribute('InterruptorGeneral')))
        self.totalPotenciaContratar = float(util.convierteCadenaISO(instalacion.getAttribute('PotenciaContratar')))
        self.inBase1 = float(util.convierteCadenaISO(instalacion.getAttribute('InBase1')))
        self.inBase2 = float(util.convierteCadenaISO(instalacion.getAttribute('InBase2')))
        self.inFusible1 = float(util.convierteCadenaISO(instalacion.getAttribute('InFusible1')))
        self.inFusible2 = float(util.convierteCadenaISO(instalacion.getAttribute('InFusible2')))
        self.inPotencia1 = float(util.convierteCadenaISO(instalacion.getAttribute('InPotencia1')))
        self.inPotencia2 = float(util.convierteCadenaISO(instalacion.getAttribute('InPotencia2')))
        self.resistenciaCalculada = float(util.convierteCadenaISO(instalacion.getAttribute('ResistenciaCalculada')))
        self.resistenciaTierra = float(util.convierteCadenaISO(instalacion.getAttribute('ResistenciaTierra')))
        self.resistenciaAislamiento = float(util.convierteCadenaISO(instalacion.getAttribute('ResistenciaAislamiento')))
        self.tomaTierra = util.convierteCadenaISO(instalacion.getAttribute('TomaTierra'))
        self.conductores = util.convierteCadenaISO(instalacion.getAttribute('Conductores'))
        self.solicitud = int(util.convierteCadenaISO(instalacion.getAttribute('Solicitud')))
        self.fechaBajaTension = util.convierteCadenaISO(instalacion.getAttribute('FechaBajaTension'))
        self.lugar = util.convierteCadenaISO(instalacion.getAttribute('Lugar'))
        self.fechaFirma = util.convierteCadenaISO(instalacion.getAttribute('FechaFirma'))
        self.otrosDocumentos = util.convierteCadenaISO(instalacion.getAttribute('OtrasDocumentaciones'))
        self.otrasInstalacionesTexto = util.convierteCadenaISO(instalacion.getAttribute('OtrasInstalaciones'))
        self.numeroRegistro = util.convierteCadenaISO(instalacion.getAttribute('NumeroRegistro'))
        self.instalacionLGA = util.convierteCadenaISO(instalacion.getAttribute('InstalacionLGA'))
        self.conductorLGA = util.convierteCadenaISO(instalacion.getAttribute('ConductorLGA'))
        self.seccionLGA = util.convierteCadenaISO(instalacion.getAttribute('SeccionLGA'))
        self.materialLGA = util.convierteCadenaISO(instalacion.getAttribute('MaterialLGA'))
        self.potenciaLGA = float(util.convierteCadenaISO(instalacion.getAttribute('PotenciaLGA')))
        self.instalacionDI = util.convierteCadenaISO(instalacion.getAttribute('InstalacionDI'))
        self.conductorDI = util.convierteCadenaISO(instalacion.getAttribute('ConductorDI'))
        self.seccionDI = util.convierteCadenaISO(instalacion.getAttribute('SeccionDI'))
        self.materialDI = util.convierteCadenaISO(instalacion.getAttribute('MaterialDI'))
        self.tensionDI = float(util.convierteCadenaISO(instalacion.getAttribute('TensionDI')))
        self.intensidadDI = float(util.convierteCadenaISO(instalacion.getAttribute('IntensidadDI')))
        self.interruptorDI = float(util.convierteCadenaISO(instalacion.getAttribute('InterruptorDI')))
        self.potenciaDI = float(util.convierteCadenaISO(instalacion.getAttribute('PotenciaDI')))
        self.otraSensibilidad = util.convierteCadenaISO(instalacion.getAttribute('OtraSensibilidad'))
        self.numeroOCA = util.convierteCadenaISO(instalacion.getAttribute('NumeroOCA'))
        self.referenciaOCA = util.convierteCadenaISO(instalacion.getAttribute('ReferenciaOCA'))
        self.fechaOCA = util.convierteCadenaISO(instalacion.getAttribute('FechaOCA'))
        self.cargaDatosReceptoresAlumbrado(instalacion.childNodes[0])
        self.cargaDatosReceptoresFuerza(instalacion.childNodes[1])
        self.cargaDatosPrevisionViviendas(instalacion.childNodes[2])
        self.cargaDatosPrevisionLocales(instalacion.childNodes[3])
        self.cargaDatosPrevisionServicios(instalacion.childNodes[4])
        self.cargaDatosPotenciaAmpliacion(instalacion.childNodes[5])
        self.cargaDatosListaCheck(instalacion.childNodes[6])
        self.cargaDatosCalculosJustificativos(instalacion.childNodes[7])
        self.cargaDatosDocumentos(instalacion.childNodes[8])
        self.cargaDatosDatosRegistro(instalacion.childNodes[9])
        self.cargaDatosOtrasInstalaciones(instalacion.childNodes[10])
        self.cargaDatosOtrasSensibilidades(instalacion.childNodes[11])
        self.cargaDatosAclaracion(instalacion.childNodes[12])
        self.cargaDatosTextoCroquis(instalacion.childNodes[13])
        self.cargaDatosImagenesCroquis(instalacion.childNodes[14])
        self.datosXML.unlink()



    def cargaDatosImagenesCroquis(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            resultado.append(util.convierteCadenaISO(elemento.getAttribute('ruta')))

        self.imagenesCroquis = resultado



    def cargaDatosAclaracion(self, nodo):
        util = Utilidades()
        try:
            self.aclaracion = util.convierteCadenaISO(nodo.childNodes[0].nodeValue)
        except:
            self.aclaracion = ''



    def cargaDatosTextoCroquis(self, nodo):
        util = Utilidades()
        try:
            self.textoCroquis = util.convierteCadenaISO(nodo.childNodes[0].nodeValue)
        except:
            self.textoCroquis = ''



    def cargaDatosReceptoresAlumbrado(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            dato = []
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Unidades')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Receptor')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Potencia')))
            resultado.append(dato)

        self.receptoresAlumbrado = resultado



    def cargaDatosReceptoresFuerza(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            dato = []
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Unidades')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Receptor')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Potencia')))
            resultado.append(dato)

        self.receptoresFuerza = resultado



    def cargaDatosPrevisionViviendas(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            dato = []
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Unidades')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Superficie')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Tarifa')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Electrificacion')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Potencia')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Total')))
            resultado.append(dato)

        self.previsionViviendas = resultado



    def cargaDatosPrevisionLocales(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            dato = []
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Unidades')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Superficie')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('CargaPrevista')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Total')))
            resultado.append(dato)

        self.previsionLocales = resultado



    def cargaDatosPrevisionServicios(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            dato = []
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Nombre')))
            if (util.convierteCadenaISO(elemento.getAttribute('Nombre')) == 'Otros servicios'):
                dato.append(util.convierteCadenaISO(elemento.getAttribute('Dato1')))
            else:
                dato.append(float(util.convierteCadenaISO(elemento.getAttribute('Dato1'))))
            try:
                dato.append(float(util.convierteCadenaISO(elemento.getAttribute('Dato2'))))
                dato.append(float(util.convierteCadenaISO(elemento.getAttribute('Dato3'))))
                dato.append(float(util.convierteCadenaISO(elemento.getAttribute('Dato4'))))
                dato.append(util.convierteCadenaISO(elemento.getAttribute('Dato5')))
            except:
                pass
            resultado.append(dato)

        self.previsionServiciosGenerales = resultado



    def cargaDatosPotenciaAmpliacion(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            dato = []
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Identificacion')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Superficie')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Tarifa')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('Electrificacion')))
            dato.append(util.convierteCadenaISO(elemento.getAttribute('APotencia')))
            resultado.append(dato)

        self.potenciaAmpliacion = resultado



    def cargaDatosListaCheck(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            resultado.append(int(util.convierteCadenaISO(elemento.getAttribute('Valor'))))

        self.listaCheck = resultado



    def cargaDatosCalculosJustificativos(self, nodo):
        datosPunto7 = []
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            datosHoja = DatosHojaCalculo()
            datosHoja.observaciones = util.convierteCadenaISO(elemento.getAttribute('observaciones'))
            datosHoja.numDiferenciales = int(util.convierteCadenaISO(elemento.getAttribute('numDiferenciales')))
            datosHoja.esquemaAplicacion = int(util.convierteCadenaISO(elemento.getAttribute('eAplicacion')))
            datosHoja.esquemaAdajunto = int(util.convierteCadenaISO(elemento.getAttribute('eAdjunto')))
            datosHoja.ficheroEsquema = util.convierteCadenaISO(elemento.getAttribute('fEsquema'))
            datosHoja.ficheroEsquemaAplicacion = util.convierteCadenaISO(elemento.getAttribute('fAplicacion'))
            for datos in elemento.childNodes:
                if (len(datos.childNodes) == 0):
                    dato = DatosCircuito()
                    dato.linea = int(util.convierteCadenaISO(datos.getAttribute('linea')))
                    dato.numeroCircuito = float(util.convierteCadenaISO(datos.getAttribute('numeroCircuito')))
                    dato.fuerza = int(util.convierteCadenaISO(datos.getAttribute('fuerza')))
                    dato.LDenominacionLinea = util.convierteCadenaISO(datos.getAttribute('LDenominacionLinea'))
                    dato.fase = int(util.convierteCadenaISO(datos.getAttribute('fase')))
                    dato.LFase = util.convierteCadenaISO(datos.getAttribute('LFase'))
                    dato.comboTension = int(util.convierteCadenaISO(datos.getAttribute('comboTension')))
                    dato.tension = int(util.convierteCadenaISO(datos.getAttribute('tension')))
                    dato.LTension = util.convierteCadenaISO(datos.getAttribute('LTension'))
                    dato.potencia = float(util.convierteCadenaISO(datos.getAttribute('potencia')))
                    dato.LPotencia = util.convierteCadenaISO(datos.getAttribute('LPotencia'))
                    dato.aislamiento = int(util.convierteCadenaISO(datos.getAttribute('aislamiento')))
                    dato.comboTensionDI = int(util.convierteCadenaISO(datos.getAttribute('comboTensionDI')))
                    dato.tensionDI = util.convierteCadenaISO(datos.getAttribute('tensionDI'))
                    dato.tipoInstalacion = int(util.convierteCadenaISO(datos.getAttribute('tipoInstalacion')))
                    dato.coeficienteCalculo = float(util.convierteCadenaISO(datos.getAttribute('coeficienteCalculo')))
                    dato.LCoeficienteCalculo = util.convierteCadenaISO(datos.getAttribute('LCoeficienteCalculo'))
                    dato.LPotenciaCalculo = util.convierteCadenaISO(datos.getAttribute('LPotenciaCalculo'))
                    dato.longitud = float(util.convierteCadenaISO(datos.getAttribute('longitud')))
                    dato.LLongitud = util.convierteCadenaISO(datos.getAttribute('LLongitud'))
                    dato.factorPotencia = float(util.convierteCadenaISO(datos.getAttribute('factorPotencia')))
                    dato.material = int(util.convierteCadenaISO(datos.getAttribute('material')))
                    dato.LIntensidad = util.convierteCadenaISO(datos.getAttribute('LIntensidad'))
                    dato.factorCorreccion = float(util.convierteCadenaISO(datos.getAttribute('factorCorreccion')))
                    dato.naturaleza = int(util.convierteCadenaISO(datos.getAttribute('naturaleza')))
                    dato.LSeccion = util.convierteCadenaISO(datos.getAttribute('LSeccion'))
                    dato.LCaidaTension = util.convierteCadenaISO(datos.getAttribute('LCaidaTension'))
                    dato.LCaidaTensionAdmisible = util.convierteCadenaISO(datos.getAttribute('LCaidaTensionAdmisible'))
                    dato.LDensidad = util.convierteCadenaISO(datos.getAttribute('LDensidad'))
                    dato.canalizacion = int(util.convierteCadenaISO(datos.getAttribute('canalizacion')))
                    dato.LCanalizacion = util.convierteCadenaISO(datos.getAttribute('LCanalizacion'))
                    dato.sensibilidadCombo = int(util.convierteCadenaISO(datos.getAttribute('sensibilidadCombo')))
                    dato.sensibilidadNumero = int(util.convierteCadenaISO(datos.getAttribute('sensibilidadNumero')))
                    dato.LSensibilidad = util.convierteCadenaISO(datos.getAttribute('LSensibilidad'))
                    dato.intensidadAdmisible = float(util.convierteCadenaISO(datos.getAttribute('intensidadAdmisible')))
                    dato.LProteccionSobre = util.convierteCadenaISO(datos.getAttribute('LProteccionSobre'))
                    datosHoja.datosCircuitos.append(dato)
                else:
                    esquema = EsquemaInstalacion()
                    esquema.protecciones = int(util.convierteCadenaISO(datos.getAttribute('proteccion')))
                    for d in datos.childNodes:
                        dif = Diferencial()
                        dif.nombre = util.convierteCadenaISO(d.getAttribute('nombre'))
                        dif.polos = util.convierteCadenaISO(d.getAttribute('polos'))
                        dif.poloSeleccionado = int(util.convierteCadenaISO(d.getAttribute('poloSeleccionado')))
                        dif.minimaProteccion = float(util.convierteCadenaISO(d.getAttribute('proteccion')))
                        dif.sensibilidad = float(util.convierteCadenaISO(d.getAttribute('sensibilidad')))
                        for c in d.childNodes:
                            cir = Circuito()
                            cir.nombre = util.convierteCadenaISO(c.getAttribute('nombre'))
                            cir.descripcion = util.convierteCadenaISO(c.getAttribute('descripcion'))
                            cir.polos = util.convierteCadenaISO(c.getAttribute('polos'))
                            cir.diferencial = util.convierteCadenaISO(c.getAttribute('diferencial'))
                            nombre = util.convierteCadenaISO(c.getAttribute('nombreDato'))
                            cir.datos = datosHoja.dameDato(nombre)
                            dif.circuitos.append(cir)

                        esquema.diferenciales.append(dif)

                    datosHoja.esquema = esquema

            datosPunto7.append(datosHoja)

        self.calculosJustificativos = datosPunto7



    def cargaDatosDocumentos(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            resultado.append(int(util.convierteCadenaISO(elemento.getAttribute('Valor'))))

        self.documentos = resultado



    def cargaDatosDatosRegistro(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            resultado.append(int(util.convierteCadenaISO(elemento.getAttribute('Valor'))))

        self.datosRegistro = resultado



    def cargaDatosOtrasInstalaciones(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            resultado.append(int(util.convierteCadenaISO(elemento.getAttribute('Valor'))))

        self.otrasInstalaciones = resultado



    def cargaDatosOtrasSensibilidades(self, nodo):
        util = Utilidades()
        resultado = []
        for elemento in nodo.childNodes:
            resultado.append(int(util.convierteCadenaISO(elemento.getAttribute('Valor'))))

        self.sensibilidadesProyecto = resultado



    def guardaTitulares(self):
        if (not (self.nombre.strip() == '')):
            util = Utilidades()
            self.datosXML = xml.dom.minidom.parse('datos/Titulares.xml')
            titulares = self.datosXML.childNodes[0]
            if (self.idTitular == 0):
                nodoTitular = self.datosXML.createElement('Titular')
                self.id1 = self.dameMaxId(titulares.childNodes)
                nodoTitular.setAttribute('IdTitular', str(self.id1))
            else:
                nodoTitular = self.dameTitularPorId(self.idTitular, titulares.childNodes)
                if (nodoTitular == 0):
                    nodoTitular = self.datosXML.createElement('Titular')
                    self.id1 = self.dameMaxId(titulares.childNodes)
                    nodoTitular.setAttribute('IdTitular', str(self.id1))
            nodoTitular.setAttribute('Nombre', util.convierteCadenaUNICODE(self.nombre))
            nodoTitular.setAttribute('DNI', util.convierteCadenaUNICODE(self.dni))
            nodoTitular.setAttribute('Domicilio', util.convierteCadenaUNICODE(self.domicilio))
            nodoTitular.setAttribute('Telefono', util.convierteCadenaUNICODE(self.telefono))
            nodoTitular.setAttribute('Provincia', util.convierteCadenaUNICODE(self.provincia))
            nodoTitular.setAttribute('Localidad', util.convierteCadenaUNICODE(self.localidad))
            nodoTitular.setAttribute('CodigoPostal', util.convierteCadenaUNICODE(self.codigoPostal))
            nodoTitular.setAttribute('Correo', util.convierteCadenaUNICODE(self.mail))
            nodoTitular.setAttribute('NombreRepresentante', util.convierteCadenaUNICODE(self.nombreRepresentante))
            nodoTitular.setAttribute('CorreoRepresentante', util.convierteCadenaUNICODE(self.correoRepresentante))
            nodoTitular.setAttribute('DniRepresentante', util.convierteCadenaUNICODE(self.dniRepresentante))
            if (self.idTitular == 0):
                self.idTitular = self.id1
                titulares.appendChild(nodoTitular)
            f = open('datos/Titulares.xml', 'w')
            cadena = self.datosXML.toxml('iso-8859-15')
            f.write(cadena)
            f.close()
            self.datosXML.unlink()



    def dameMaxId(self, hijos):
        maxId = 0
        for nodo in hijos:
            if isinstance(nodo, xml.dom.minidom.Element):
                if (maxId < int(nodo.getAttribute('IdTitular'))):
                    maxId = int(nodo.getAttribute('IdTitular'))

        maxId = (maxId + 1)
        return maxId



    def dameTitularPorId(self, id, hijos):
        for nodo in hijos:
            if isinstance(nodo, xml.dom.minidom.Element):
                if (nodo.getAttribute('IdTitular') == str(id)):
                    return nodo

        return 0



    def guardaRedactores(self):
        if (not (self.Rnombre.strip() == '')):
            util = Utilidades()
            self.datosXML = xml.dom.minidom.parse('datos/Redactores.xml')
            redactor = self.datosXML.childNodes[0]
            if (self.idRedactor == 0):
                nodoTitular = self.datosXML.createElement('Redactor')
                self.id2 = self.dameMaxIdRedactor(redactor.childNodes)
                nodoTitular.setAttribute('IdRedactor', str(self.id2))
            else:
                nodoTitular = self.dameRedactorPorId(self.idRedactor, redactor.childNodes)
                if (nodoTitular == 0):
                    nodoTitular = self.datosXML.createElement('Redactor')
                    self.id2 = self.dameMaxIdRedactor(redactor.childNodes)
                    nodoTitular.setAttribute('IdRedactor', str(self.id2))
            nodoTitular.setAttribute('Nombre', util.convierteCadenaUNICODE(self.Rnombre))
            nodoTitular.setAttribute('DNI', util.convierteCadenaUNICODE(self.Rdni))
            nodoTitular.setAttribute('Domicilio', util.convierteCadenaUNICODE(self.Rdomicilio))
            nodoTitular.setAttribute('Telefono', util.convierteCadenaUNICODE(self.Rtelefono))
            nodoTitular.setAttribute('Provincia', util.convierteCadenaUNICODE(self.Rprovincia))
            nodoTitular.setAttribute('Localidad', util.convierteCadenaUNICODE(self.Rlocalidad))
            nodoTitular.setAttribute('CodigoPostal', util.convierteCadenaUNICODE(self.RcodigoPostal))
            nodoTitular.setAttribute('Correo', util.convierteCadenaUNICODE(self.Rmail))
            nodoTitular.setAttribute('Carne', util.convierteCadenaUNICODE(self.RCarne))
            nodoTitular.setAttribute('Categoria', util.convierteCadenaUNICODE(self.RCategoria))
            nodoTitular.setAttribute('Registro', util.convierteCadenaUNICODE(self.RRegistro))
            nodoTitular.setAttribute('Ingeniero', util.convierteCadenaUNICODE(str(self.RIngeniero)))
            nodoTitular.setAttribute('NombreRepresentante', util.convierteCadenaUNICODE(self.nombreRepresentante))
            nodoTitular.setAttribute('CorreoRepresentante', util.convierteCadenaUNICODE(self.correoRepresentante))
            nodoTitular.setAttribute('DniRepresentante', util.convierteCadenaUNICODE(self.dniRepresentante))
            nodoTitular.setAttribute('NombreEmpresa', util.convierteCadenaUNICODE(self.REmpresa))
            if (self.idRedactor == 0):
                self.idRedactor = self.id2
                redactor.appendChild(nodoTitular)
            f = open('datos/Redactores.xml', 'w')
            cadena = self.datosXML.toxml('iso-8859-15')
            f.write(cadena)
            f.close()
            self.datosXML.unlink()



    def dameMaxIdRedactor(self, hijos):
        maxId = 0
        for nodo in hijos:
            if isinstance(nodo, xml.dom.minidom.Element):
                if (maxId < int(nodo.getAttribute('IdRedactor'))):
                    maxId = int(nodo.getAttribute('IdRedactor'))

        maxId = (maxId + 1)
        return maxId



    def dameRedactorPorId(self, id, hijos):
        for nodo in hijos:
            if isinstance(nodo, xml.dom.minidom.Element):
                if (nodo.getAttribute('IdRedactor') == str(id)):
                    return nodo

        return 0



    def dameResumenViviendas(self):
        coeficienteSimultaneidad = {'1': '1',
         '2': '2',
         '3': '3',
         '4': '3.8',
         '5': '4.6',
         '6': '5.4',
         '7': '6.2',
         '8': '7',
         '9': '7.8',
         '10': '8.5',
         '11': '9.2',
         '12': '9.9',
         '13': '10.6',
         '14': '11.3',
         '15': '11.9',
         '16': '12.5',
         '17': '13.1',
         '18': '13.7',
         '19': '14.3',
         '20': '14.8',
         '21': '15.3'}
        resumen = [0,
         0,
         0,
         0,
         0,
         0]
        solucion = [0,
         0,
         0,
         0,
         0,
         0]
        for prevision in self.previsionViviendas:
            (unidades, superficie, tarifa, electrificacion, potencia, total,) = prevision
            if (tarifa == 'No'):
                resumen[3] = (resumen[3] + (int(unidades) * float(potencia)))
                resumen[4] = (resumen[4] + int(unidades))
                try:
                    solucion[3] = (resumen[3] / resumen[4])
                except:
                    solucion[3] = 0
                try:
                    solucion[4] = float(coeficienteSimultaneidad[str(resumen[4])])
                except:
                    solucion[4] = (15.300000000000001 + ((resume[4] - 21) * 0.5))
                solucion[5] = (solucion[3] * solucion[4])
                resumen[5] = solucion[5]
            else:
                resumen[0] = (resumen[0] + (int(unidades) * float(potencia)))
                resumen[1] = (resumen[1] + int(unidades))
                try:
                    solucion[0] = (resumen[0] / resumen[1])
                except:
                    solucion[0] = 0
                solucion[1] = resumen[1]
                solucion[2] = (solucion[0] * solucion[1])
                resumen[2] = solucion[2]

        return solucion



    def compruebaProyecto(self):
        if (self.ITipo == ''):
            return 0
        if ((self.ITipo[0] == 'i') or ((self.ITipo[0] == 'l') or (self.ITipo[0] == 'm'))):
            return 1
        if (self.ITipo[0] == 'h'):
            if (self.IOcupacion > 5):
                return 1
            else:
                return 0
        if (self.ITipo[0] == 'j'):
            if (self.IProyecto == 1):
                return 1
            else:
                return 0
        suma = self.dameSuma41()
        if (self.ITipo[0] == 'a'):
            if (suma > 20):
                return 1
            else:
                return 0
        if ((self.ITipo[0] == 'b') or ((self.ITipo[0] == 'c') or (self.ITipo[0] == 'x'))):
            if (suma > 10):
                return 1
            else:
                return 0
        if ((self.ITipo[0] == 'd') or (self.ITipo[0] == 'z')):
            if (suma > 50):
                return 1
            else:
                return 0
        if ((self.ITipo[0] == 'k') or (self.ITipo[0] == 'n')):
            if (suma > 5):
                return 1
            else:
                return 0
        if ((self.ITipo[0] == 'e') and (self.IInstalacion == 2)):
            if (suma > 100):
                return 1
            else:
                return 0
        if (self.ITipo[0] == 'f'):
            if ((self.IInstalacion == 1) or (self.IInstalacion == 2)):
                if (suma > 50):
                    return 1
                else:
                    return 0
        if ((self.ITipo[0] == 'f') and (self.IInstalacion == 0)):
            if (self.prevision > 50):
                return 1
            else:
                return 0
        suma = ((self.totalPrevisionViviendas + self.totalPrevisionLocales) + self.totalPrevisionServicios)
        if ((self.ITipo[0] == 'e') and (self.IInstalacion == 0)):
            if (suma > 100):
                return 1
            else:
                return 0
        suma = (((self.viviendasSin + self.viviendasCon) + self.locales) + self.servicios)
        if ((self.ITipo[0] == 'e') and (self.IInstalacion == 1)):
            if (suma > 100):
                return 1
            else:
                return 0
        return 0



    def dameSuma41(self):
        sumaAlumbrado = 0
        sumaFuerza = 0
        for receptor in self.receptoresAlumbrado:
            sumaAlumbrado = (sumaAlumbrado + float(receptor[2]))

        for receptor in self.receptoresFuerza:
            sumaFuerza = (sumaFuerza + float(receptor[2]))

        sumaTotal = (sumaAlumbrado + sumaFuerza)
        return sumaTotal



    def dameDatosLGA(self):
        lga = []
        for hoja in self.calculosJustificativos:
            datolga = hoja.dameDatosLGA()
            if datolga:
                lga.append(datolga)

        return lga



    def dameDatosDI(self):
        for hoja in self.calculosJustificativos:
            di = hoja.dameDatosDI()
            if (not (di == '')):
                return di

        return 0



    def dameInterruptorDI(self):
        for hoja in self.calculosJustificativos:
            return hoja.dameInterruptorDI()

        return ''



    def dameSensibilidad(self):
        solucion = [0,
         0,
         0,
         0,
         '']
        for hoja in self.calculosJustificativos:
            for circuito in hoja.datosCircuitos:
                if ((circuito.LSensibilidad == '10.0') or (circuito.LSensibilidad == '10')):
                    solucion[0] = 1
                elif ((circuito.LSensibilidad == '30.0') or (circuito.LSensibilidad == '30')):
                    solucion[1] = 1
                elif ((circuito.LSensibilidad == '300.0') or (circuito.LSensibilidad == '300')):
                    solucion[2] = 1
                elif (circuito.LSensibilidad == '0'):
                    pass
                else:
                    solucion[3] = 1
                    solucion[4] = circuito.LSensibilidad


        return solucion



    def dameLGA(self):
        for hoja in self.calculosJustificativos:
            for circuito in hoja.datosCircuitos:
                if (circuito.linea == 0):
                    return circuito


        return ''



    def dameDI(self):
        for hoja in self.calculosJustificativos:
            for circuito in hoja.datosCircuitos:
                if (circuito.linea == 1):
                    return circuito


        return ''



class EsquemaInstalacion:
    __module__ = __name__

    def __init__(self, circuitos = None, resultados = None, textos = None, listaDiferenciales = None, polos = None):
        self.diferenciales = []
        self.protecciones = 0
        if (circuitos and (resultados and (textos and (listaDiferenciales and polos)))):
            for diferencial in listaDiferenciales:
                self.diferenciales.append(Diferencial(diferencial))

            for i in range(len(circuitos)):
                circuitos[i].descripcion = textos[i]
                circuitos[i].polos = polos[i]
                circuitos[i].diferencial = resultados[i]
                dif = self.dameDiferencial(resultados[i])
                dif.circuitos.append(circuitos[i])

            for i in range(len(self.diferenciales)):
                if (len(self.diferenciales[i].circuitos) == 0):
                    del self.diferenciales[i]




    def dameDiferencial(self, nombre):
        for diferencial in self.diferenciales:
            if (diferencial.nombre == nombre):
                return diferencial




class Diferencial:
    __module__ = __name__

    def __init__(self, nombre = None):
        self.nombre = nombre
        self.circuitos = []
        self.minimaProteccion = 0
        self.sensibilidad = 1000
        self.polos = ''
        self.poloSeleccionado = -1



    def calculaMinimaProteccion(self):
        for circuito in self.circuitos:
            self.minimaProteccion = (self.minimaProteccion + float(circuito.datos.LIntensidad))




    def calculaSensibilidad(self):
        for circuito in self.circuitos:
            if (float(circuito.datos.LSensibilidad) != 0):
                if (float(circuito.datos.LSensibilidad) < self.sensibilidad):
                    self.sensibilidad = float(circuito.datos.LSensibilidad)




class Circuito:
    __module__ = __name__

    def __init__(self):
        self.nombre = ''
        self.descripcion = ''
        self.polos = ''
        self.diferencial = ''
        self.datos = ''



class DatosHojaCalculo:
    __module__ = __name__

    def __init__(self):
        self.linea = -1
        self.numeroCircuito = 0
        self.fuerza = -1
        self.fase = -1
        self.comboTension = -1
        self.tension = 0
        self.potencia = 0
        self.aislamiento = -1
        self.comboTensionDI = -1
        self.tensionDI = ''
        self.tipoInstalacion = -1
        self.coeficienteCalculo = 1
        self.longitud = 0
        self.factorPotencia = 0.90000000000000002
        self.material = -1
        self.factorCorreccion = 1
        self.naturaleza = -1
        self.canalizacion = -1
        self.sensibilidadCombo = -1
        self.sensibilidadNumero = 0
        self.observaciones = ''
        self.numDiferenciales = 0
        self.esquema = ''
        self.esquemaAplicacion = 1
        self.esquemaAdjunto = 0
        self.ficheroEsquema = ''
        self.ficheroEsquemaAplicacion = ''
        self.datosCircuitos = []



    def inserta(self, datos):
        self.datosCircuitos.append(datos)
        self.datosCircuitos.sort()



    def existeLinea(self, nombre):
        for datos in self.datosCircuitos:
            if (datos.LDenominacionLinea == nombre):
                return 1

        return 0



    def elimina(self, nombreDato):
        aux = []
        for dato in self.datosCircuitos:
            if (not (dato.LDenominacionLinea == nombreDato)):
                aux.append(dato)

        self.datosCircuitos = aux
        self.datosCircuitos.sort()



    def dameDato(self, nombreDato):
        for dato in self.datosCircuitos:
            if (dato.LDenominacionLinea == nombreDato):
                return dato

        return 0



    def compruebaCircuitos(self):
        for circuitos in self.datosCircuitos:
            if (circuitos.linea == 2):
                return 1

        return 0



    def numeroCircuitos(self):
        numero = 0
        for circuitos in self.datosCircuitos:
            if (circuitos.linea == 2):
                numero = (numero + 1)

        return numero



    def dameCircuitos(self):
        dic = {'1': 'b',
         '2': 'c',
         '3': 'd',
         '4': 'e',
         '5': 'f',
         '6': 'g',
         '7': 'h',
         '8': 'i',
         '9': 'j'}
        circuitos = []
        numero = []
        for circuito in self.datosCircuitos:
            if (circuito.linea == 2):
                c = Circuito()
                cadena = circuito.LDenominacionLinea.split('.')
                if (len(cadena) == 2):
                    c.nombre = circuito.LDenominacionLinea
                else:
                    for i in range(len(numero)):
                        if (((cadena[0] + '.') + cadena[1]) == numero[i].nombre):
                            numero[i].nombre = (numero[i].nombre + '.a')

                    letra = dic[cadena[2]]
                    c.nombre = ((((cadena[0] + '.') + cadena[1]) + '.') + letra)
                c.datos = circuito
                numero.append(c)

        if (not (self.esquema == '')):
            for i in range(len(numero)):
                numero[i] = self.cargaDatosCircuito(numero[i])

        return numero



    def cargaDatosCircuito(self, circuito):
        for d in self.esquema.diferenciales:
            for c in d.circuitos:
                if (c.nombre == circuito.nombre):
                    return c


        return circuito



    def dameDatosLGA(self):
        for datos in self.datosCircuitos:
            if (datos.linea == 0):
                return datos.dameDatosLGA()

        return 0



    def dameDatosDI(self):
        for datos in self.datosCircuitos:
            if (datos.linea == 1):
                return datos.dameDatosDI()

        return 0



    def dameInterruptorDI(self):
        for datos in self.datosCircuitos:
            if (datos.linea == 1):
                return datos.dameInterruptorDI()

        return ''



class DatosCircuito:
    __module__ = __name__

    def __init__(self):
        self.linea = -1
        self.numeroCircuito = 0
        self.fuerza = -1
        self.LDenominacionLinea = ''
        self.fase = -1
        self.LFase = ''
        self.comboTension = -1
        self.tension = 0
        self.LTension = ''
        self.potencia = 0
        self.LPotencia = ''
        self.aislamiento = -1
        self.comboTensionDI = -1
        self.tensionDI = ''
        self.tipoInstalacion = -1
        self.coeficienteCalculo = 1
        self.LCoeficienteCalculo = ''
        self.LPotenciaCalculo = ''
        self.longitud = 0
        self.LLongitud = ''
        self.factorPotencia = 0.90000000000000002
        self.material = -1
        self.LIntensidad = ''
        self.factorCorreccion = 1
        self.intensidadCorregida = 0
        self.naturaleza = -1
        self.LSeccion = ''
        self.LCaidaTension = ''
        self.LCaidaTensionAdmisible = ''
        self.LDensidad = ''
        self.canalizacion = -1
        self.LCanalizacion = ''
        self.sensibilidadCombo = -1
        self.sensibilidadNumero = 0
        self.LSensibilidad = ''
        self.intensidadAdmisible = 0
        self.LProteccionSobre = ''
        self.tablaIntensidades = []
        self.tablaSecciones = []
        self.listaProtecciones = []



    def construyeDenominacionLinea(self):
        if (self.linea == -1):
            return 0
        if (self.linea == 0):
            self.LDenominacionLinea = 'L.G.A.'
            return 1
        if (self.linea == 1):
            if (self.numeroCircuito == 0):
                self.LDenominacionLinea = 'D.I.'
                return 1
            cadena = str(self.numeroCircuito)
            cadena = cadena.split('.')
            if (not (int(cadena[1]) == 0)):
                return 0
            self.LDenominacionLinea = ('D.I.' + cadena[0])
            return 1
        if (self.linea == 2):
            if (self.numeroCircuito < 1):
                return 0
            cadena = str(self.numeroCircuito)
            cadena = cadena.split('.')
            if (int(cadena[1]) == 0):
                self.LDenominacionLinea = ('C.' + cadena[0])
            else:
                self.LDenominacionLinea = ((('C.' + cadena[0]) + '.') + cadena[1])
            return 1
        return 0



    def construyeFase(self):
        if (self.fase == -1):
            return 0
        if (self.fase == 0):
            self.LFase = 'II - Monof\xe1sico'
        else:
            self.LFase = 'III - Trif\xe1sico'
        return 1



    def construyeTension(self):
        if (self.tension < 1):
            return 0
        if (self.tension > 1500):
            return 0
        self.LTension = str(self.tension)
        return 1



    def construyePotencia(self):
        if (self.potencia > 0):
            self.LPotencia = str(self.potencia)
            return 1
        return 0



    def construyeCoeficienteCalculo(self):
        if (self.coeficienteCalculo > 0):
            self.LCoeficienteCalculo = str(self.coeficienteCalculo)
            return 1
        return 0



    def construyePotenciaCalculo(self):
        calculo = (self.potencia * self.coeficienteCalculo)
        self.LPotenciaCalculo = str(calculo)



    def construyeLongitud(self):
        if (self.longitud > 0):
            self.LLongitud = str(self.longitud)
            return 1
        return 0



    def construyeIntensidad(self):
        if (self.factorPotencia > 1):
            return 0
        if (self.factorPotencia < 0.69999999999999996):
            return 0
        if (self.fase == 0):
            intensidad = ((self.potencia * self.coeficienteCalculo) / (self.tension * self.factorPotencia))
        else:
            import math
            intensidad = ((self.potencia * self.coeficienteCalculo) / ((math.sqrt(3) * self.tension) * self.factorPotencia))
        self.LIntensidad = str(round(intensidad, 2))
        return 1



    def construyeIntensidadCorregida(self):
        if (self.factorCorreccion > 0):
            self.intensidadCorregida = (float(self.LIntensidad) / self.factorCorreccion)
            return 1
        return 0



    def construyeSeccion(self):
        if (self.tipoInstalacion == -1):
            return 0
        if (self.tipoInstalacion == 0):
            seccion = self.dameSeccionAerea()
        if (self.tipoInstalacion == 1):
            seccion = self.dameSeccionSEnterrada()
        if (self.tipoInstalacion == 2):
            seccion = self.dameSeccionSAire()
        if (self.tipoInstalacion in (3,
         4)):
            seccion = self.dameSeccionInstalacionesInteriores()
        if (seccion == 0):
            return 0
        self.LSeccion = str(seccion)
        return 1



    def dameSeccionInstalacionesInteriores(self):
        if (self.naturaleza == -1):
            return 0
        if (self.aislamiento == -1):
            return 0
        if (self.material == -1):
            return 0
        if (self.material == 0):
            tabla = self.dameTablaIntensidadesAdmisiblesInstalacionesCU()
        else:
            tabla = self.dameTablaIntensidadesAdmisiblesInstalacionesAL()
        if (self.naturaleza == 0):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[1], tabla[11])
            if ((self.aislamiento == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[2], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[4], tabla[11])
            if (self.fase == 0):
                return self.buscarSeccion(tabla[5], tabla[11])
            return 0
        if (self.naturaleza == 1):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[0], tabla[11])
            if ((self.aislamiento == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[1], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[3], tabla[11])
            if (self.fase == 0):
                return self.buscarSeccion(tabla[4], tabla[11])
            return 0
        if (self.naturaleza == 2):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[3], tabla[11])
            if ((self.aislamiento == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[4], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[7], tabla[11])
            if (self.fase == 0):
                return self.buscarSeccion(tabla[8], tabla[11])
            return 0
        if (self.naturaleza == 3):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[2], tabla[11])
            if ((self.aislamiento == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[3], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[5], tabla[11])
            if (self.fase == 0):
                return self.buscarSeccion(tabla[7], tabla[11])
            return 0
        if (self.naturaleza == 4):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[4], tabla[11])
            if ((self.aislamiento == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[5], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[7], tabla[11])
            if (self.fase == 0):
                return self.buscarSeccion(tabla[8], tabla[11])
            return 0
        if (self.naturaleza == 5):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[5], tabla[11])
            if ((self.aislamiento == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[7], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[8], tabla[11])
            if (self.fase == 0):
                return self.buscarSeccion(tabla[9], tabla[11])
            return 0
        if (self.naturaleza == 6):
            if ((self.aislamiento == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[6], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[9], tabla[11])
            return 0
        if (self.naturaleza == 7):
            if ((self.aislamiento == 0) and (self.fase == 1)):
                return self.buscarSeccion(tabla[8], tabla[11])
            if (self.fase == 1):
                return self.buscarSeccion(tabla[10], tabla[11])
            return 0



    def dameTablaIntensidadesAdmisiblesInstalacionesCU(self):
        Columna1 = [11,
         15,
         20,
         25,
         34,
         45,
         59]
        Columna2 = [11.5,
         16,
         21,
         27,
         37,
         49,
         64,
         77,
         94]
        Columna3 = [13,
         17.5,
         23,
         30,
         40,
         54,
         70,
         86,
         103]
        Columna4 = [13.5,
         18.5,
         24,
         32,
         44,
         59,
         77,
         96,
         117,
         149,
         180,
         208,
         236,
         268,
         315,
         360]
        Columna5 = [15,
         21,
         27,
         36,
         50,
         66,
         84,
         104,
         125,
         160,
         194,
         225,
         260,
         297,
         350,
         404]
        Columna6 = [16,
         22,
         30,
         37,
         52,
         70,
         88,
         110,
         133,
         171,
         207,
         240,
         278,
         317,
         374,
         423]
        Columna7 = [0,
         0,
         0,
         0,
         0,
         0,
         96,
         119,
         145,
         188,
         230,
         267,
         310,
         354,
         419,
         484]
        Columna8 = [18,
         25,
         34,
         44,
         60,
         80,
         106,
         131,
         159,
         202,
         245,
         284,
         338,
         386,
         455,
         524]
        Columna9 = [21,
         29,
         38,
         49,
         68,
         91,
         116,
         144,
         175,
         224,
         271,
         314,
         363,
         415,
         490,
         565]
        Columna10 = [24,
         33,
         45,
         57,
         76,
         105,
         123,
         154,
         188,
         244,
         296,
         348,
         404,
         464,
         552,
         640]
        Columna11 = [0,
         0,
         0,
         0,
         0,
         0,
         166,
         206,
         250,
         321,
         391,
         455,
         525,
         601,
         711,
         821]
        resultado = [1.5,
         2.5,
         4,
         6,
         10,
         16,
         25,
         35,
         50,
         70,
         95,
         120,
         150,
         185,
         240,
         300]
        tabla = [Columna1,
         Columna2,
         Columna3,
         Columna4,
         Columna5,
         Columna6,
         Columna7,
         Columna8,
         Columna9,
         Columna10,
         Columna11,
         resultado]
        return tabla



    def dameTablaIntensidadesAdmisiblesInstalacionesAL(self):
        Columna1 = [11.5,
         15,
         20,
         27,
         36,
         46]
        Columna2 = [12.16,
         21,
         28,
         38,
         50,
         61,
         73]
        Columna3 = [13.5,
         18.5,
         24,
         32,
         42,
         54,
         67,
         80]
        Columna4 = [14,
         19,
         25,
         34,
         46,
         61,
         75,
         90,
         116,
         140,
         162,
         187,
         212,
         248,
         285]
        Columna5 = [16,
         22,
         28,
         38,
         51,
         64,
         78,
         96,
         122,
         148,
         171,
         197,
         225,
         265,
         305]
        Columna6 = [17.5,
         24,
         30,
         42,
         56,
         71,
         88,
         106,
         136,
         167,
         193,
         223,
         236,
         300,
         347]
        Columna7 = [0,
         0,
         0,
         0,
         0,
         73,
         92,
         110,
         144,
         177,
         206,
         238,
         274,
         326,
         378]
        Columna8 = [20,
         25,
         35,
         47,
         65,
         82,
         102,
         124,
         158,
         192,
         223,
         258,
         294,
         348,
         400]
        Columna9 = [22,
         29,
         38,
         53,
         70,
         88,
         109,
         133,
         170,
         207,
         239,
         277,
         316,
         372,
         429]
        Columna10 = [25,
         35,
         45,
         61,
         83,
         94,
         117,
         145,
         187,
         230,
         269,
         312,
         359,
         429,
         498]
        Columna11 = [0,
         0,
         0,
         0,
         0,
         126,
         157,
         191,
         247,
         302,
         352,
         406,
         469,
         556,
         644]
        resultado = [2.5,
         4,
         6,
         10,
         16,
         25,
         35,
         50,
         70,
         95,
         120,
         150,
         185,
         240,
         300]
        tabla = [Columna1,
         Columna2,
         Columna3,
         Columna4,
         Columna5,
         Columna6,
         Columna7,
         Columna8,
         Columna9,
         Columna10,
         Columna11,
         resultado]
        return tabla



    def dameSeccionAerea(self):
        if (self.naturaleza == -1):
            return 0
        if (self.material == -1):
            return 0
        tabla = self.dameTablaIntensidadesAdmisiblesAerea()
        if (self.naturaleza == 0):
            if ((self.material == 0) and (self.fase == 1)):
                return self.buscarSeccion(tabla[6], tabla[11])
            if ((self.material == 0) and (self.fase == 0)):
                return 10
            if ((self.material == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[0], tabla[8])
            if ((self.material == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[1], tabla[9])
            return 0
        if (self.naturaleza == 1):
            if ((self.material == 0) and (self.fase == 1)):
                return self.buscarSeccion(tabla[7], tabla[11])
            if ((self.material == 0) and (self.fase == 0)):
                return 10
            if ((self.material == 1) and (self.fase == 0)):
                return self.buscarSeccion(tabla[2], tabla[8])
            if ((self.material == 1) and (self.fase == 1)):
                return self.buscarSeccion(tabla[3], tabla[9])
            return 0
        return 0



    def dameTablaIntensidadesAdmisiblesAerea(self):
        columna1 = [73,
         101]
        columna2 = [67,
         90,
         133,
         207,
         277]
        columna3 = [81,
         109]
        columna4 = [72,
         97,
         144,
         223,
         301]
        resultadoMono = [16,
         25]
        resultadoTri = [16,
         25,
         50,
         95,
         150]
        columnaCu1 = [77]
        columnaCu2 = [85]
        columnaCu3 = [65,
         86]
        columnaCu4 = [72,
         95]
        resultadoMonoCu = [10]
        resultadoTriCu = [10,
         16]
        tabla = [columna1,
         columna2,
         columna3,
         columna4,
         columnaCu1,
         columnaCu2,
         columnaCu3,
         columnaCu4,
         resultadoMono,
         resultadoTri,
         resultadoMonoCu,
         resultadoTriCu]
        return tabla



    def dameSeccionSEnterrada(self):
        if (self.naturaleza == -1):
            return 0
        if (self.aislamiento == -1):
            return 0
        if (self.material == -1):
            return 0
        tabla = self.dameTablaIntensidadesAdmisiblesSEnterrada()
        if (self.material == 1):
            if ((self.naturaleza == 0) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[2], tabla[12])
            if ((self.naturaleza == 0) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[1], tabla[12])
            if ((self.naturaleza == 0) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[0], tabla[12])
            if ((self.naturaleza == 1) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[5], tabla[12])
            if ((self.naturaleza == 1) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[4], tabla[12])
            if ((self.naturaleza == 1) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[3], tabla[12])
            if ((self.naturaleza == 2) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[2], tabla[12], 1.2250000000000001)
            if ((self.naturaleza == 2) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[1], tabla[12], 1.2250000000000001)
            if ((self.naturaleza == 2) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[0], tabla[12], 1.2250000000000001)
            if ((self.naturaleza == 3) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[5], tabla[12], 1.2250000000000001)
            if ((self.naturaleza == 3) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[4], tabla[12], 1.2250000000000001)
            if ((self.naturaleza == 3) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[3], tabla[12], 1.2250000000000001)
            return 0
        if (self.material == 0):
            if ((self.naturaleza == 0) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[8], tabla[13])
            if ((self.naturaleza == 0) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[7], tabla[13])
            if ((self.naturaleza == 0) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[6], tabla[13])
            if ((self.naturaleza == 1) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[11], tabla[13])
            if ((self.naturaleza == 1) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[10], tabla[13])
            if ((self.naturaleza == 1) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[9], tabla[13])
            if ((self.naturaleza == 2) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[8], tabla[13], 1.2250000000000001)
            if ((self.naturaleza == 2) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[7], tabla[13], 1.2250000000000001)
            if ((self.naturaleza == 2) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[6], tabla[13], 1.2250000000000001)
            if ((self.naturaleza == 3) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[11], tabla[13], 1.2250000000000001)
            if ((self.naturaleza == 3) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[10], tabla[13], 1.2250000000000001)
            if ((self.naturaleza == 3) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[9], tabla[13], 1.2250000000000001)
            return 0



    def dameTablaIntensidadesAdmisiblesSEnterrada(self):
        columna1 = [97,
         125,
         150,
         180,
         220,
         260,
         295,
         330,
         375,
         430,
         485,
         550,
         615,
         690]
        columna2 = [94,
         120,
         145,
         175,
         215,
         255,
         290,
         325,
         365,
         420,
         475,
         540,
         605,
         680]
        columna3 = [86,
         110,
         130,
         155,
         190,
         225,
         260,
         290,
         325,
         380,
         430,
         480,
         525,
         600]
        columna4 = [90,
         115,
         140,
         165,
         205,
         240,
         275,
         310,
         350,
         405,
         460,
         520]
        columna5 = [86,
         110,
         135,
         160,
         220,
         235,
         270,
         305,
         345,
         395,
         445,
         500]
        columna6 = [76,
         98,
         120,
         140,
         170,
         210,
         235,
         265,
         300,
         350,
         395,
         445]
        columna7 = [72,
         96,
         125,
         160,
         190,
         230,
         280,
         335,
         380,
         425,
         480,
         550,
         620,
         705,
         790,
         885]
        columna8 = [70,
         94,
         120,
         155,
         185,
         225,
         270,
         325,
         375,
         415,
         470,
         540,
         610,
         690,
         775,
         870]
        columna9 = [63,
         85,
         110,
         140,
         170,
         200,
         245,
         290,
         335,
         370,
         420,
         485,
         550,
         615,
         685,
         770]
        columna10 = [66,
         88,
         115,
         150,
         180,
         215,
         260,
         310,
         355,
         400,
         450,
         520,
         590,
         665]
        columna11 = [64,
         85,
         110,
         140,
         175,
         205,
         250,
         305,
         350,
         390,
         440,
         505,
         565,
         645]
        columna12 = [56,
         75,
         97,
         125,
         150,
         180,
         220,
         265,
         305,
         340,
         385,
         445,
         505,
         570]
        resultado1 = [16,
         25,
         35,
         50,
         70,
         95,
         120,
         150,
         185,
         240,
         300,
         400,
         500,
         630]
        resultado2 = [6,
         10,
         16,
         25,
         35,
         50,
         70,
         95,
         120,
         150,
         185,
         240,
         300,
         400,
         500,
         630]
        tabla = [columna1,
         columna2,
         columna3,
         columna4,
         columna5,
         columna6,
         columna7,
         columna8,
         columna9,
         columna10,
         columna11,
         columna12,
         resultado1,
         resultado2]
        return tabla



    def dameSeccionSAire(self):
        if (self.naturaleza == -1):
            return 0
        if (self.aislamiento == -1):
            return 0
        if (self.material == -1):
            return 0
        tabla = self.dameTablaIntensidadesAdmisiblesSAire()
        if (self.material == 1):
            if ((self.naturaleza == 0) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[2], tabla[12])
            if ((self.naturaleza == 0) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[1], tabla[12])
            if ((self.naturaleza == 0) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[0], tabla[12])
            if ((self.naturaleza == 1) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[5], tabla[12])
            if ((self.naturaleza == 1) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[4], tabla[12])
            if ((self.naturaleza == 1) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[3], tabla[12])
            return 0
        if (self.material == 0):
            if ((self.naturaleza == 0) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[8], tabla[13])
            if ((self.naturaleza == 0) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[7], tabla[13])
            if ((self.naturaleza == 0) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[6], tabla[13])
            if ((self.naturaleza == 1) and (self.aislamiento == 1)):
                return self.buscarSeccion(tabla[11], tabla[13])
            if ((self.naturaleza == 1) and (self.aislamiento == 2)):
                return self.buscarSeccion(tabla[10], tabla[13])
            if ((self.naturaleza == 1) and (self.aislamiento == 0)):
                return self.buscarSeccion(tabla[9], tabla[13])
            return 0



    def dameTablaIntensidadesAdmisiblesSAire(self):
        columna1 = [67,
         93,
         115,
         140,
         180,
         220,
         260,
         300,
         350,
         420,
         480,
         560,
         645,
         740]
        columna2 = [65,
         90,
         110,
         135,
         175,
         215,
         255,
         290,
         345,
         400,
         465,
         545,
         625,
         715]
        columna3 = [55,
         75,
         90,
         115,
         145,
         180,
         215,
         245,
         285,
         340,
         390,
         455,
         520,
         600]
        columna4 = [64,
         85,
         105,
         130,
         165,
         205,
         235,
         275,
         315,
         370,
         425,
         505]
        columna5 = [63,
         82,
         100,
         125,
         155,
         195,
         225,
         260,
         300,
         360,
         405,
         475]
        columna6 = [51,
         68,
         82,
         100,
         130,
         160,
         185,
         215,
         245,
         290,
         335,
         385]
        columna7 = [46,
         64,
         86,
         120,
         145,
         180,
         230,
         285,
         335,
         385,
         450,
         535,
         615,
         720,
         825,
         950]
        columna8 = [45,
         62,
         83,
         115,
         140,
         175,
         225,
         280,
         325,
         375,
         440,
         515,
         595,
         700,
         800,
         915]
        columna9 = [38,
         53,
         71,
         96,
         115,
         145,
         185,
         235,
         275,
         315,
         365,
         435,
         500,
         535,
         665,
         765]
        columna10 = [44,
         61,
         82,
         110,
         135,
         165,
         210,
         260,
         300,
         350,
         400,
         475,
         545,
         645]
        columna11 = [43,
         60,
         80,
         105,
         130,
         160,
         220,
         250,
         290,
         335,
         385,
         460,
         520,
         610]
        columna12 = [36,
         50,
         65,
         87,
         105,
         130,
         165,
         205,
         240,
         275,
         315,
         370,
         425,
         495]
        resultado1 = [16,
         25,
         35,
         50,
         70,
         95,
         120,
         150,
         185,
         240,
         300,
         400,
         500,
         630]
        resultado2 = [6,
         10,
         16,
         25,
         35,
         50,
         70,
         95,
         120,
         150,
         185,
         240,
         300,
         400,
         500,
         630]
        tabla = [columna1,
         columna2,
         columna3,
         columna4,
         columna5,
         columna6,
         columna7,
         columna8,
         columna9,
         columna10,
         columna11,
         columna12,
         resultado1,
         resultado2]
        return tabla



    def buscarSeccion(self, intensidades, secciones, multiplo = None):
        self.tablaSecciones = secciones
        datos = []
        if multiplo:
            for i in range(len(intensidades)):
                datos.append((intensidades[i] * multiplo))

        else:
            datos = intensidades
        self.tablaIntensidades = datos
        for i in range(len(datos)):
            if (datos[i] >= self.intensidadCorregida):
                break

        self.resultadoBuscado = i
        self.intensidadAdmisible = datos[i]
        return secciones[i]



    def construyeCaidaTension(self):
        if (self.material == -1):
            return 0
        if (self.material == 0):
            constante = 56
        else:
            constante = 35
        divisor = (((constante * float(self.LSeccion)) * self.tension) * self.tension)
        if (self.fase == 0):
            caidaTension = ((((2 * float(self.LPotenciaCalculo)) * float(self.LLongitud)) * 100) / divisor)
        else:
            caidaTension = (((float(self.LPotenciaCalculo) * float(self.LLongitud)) * 100) / divisor)
        self.LCaidaTension = str(round(caidaTension, 2))
        return 1



    def construyeCaidaTensionAdmisible(self, tipo, contadores):
        if (self.linea == 2):
            if (tipo == 'f - Viviendas unifamiliares'):
                self.LCaidaTensionAdmisible = '3'
                return 1
            if (self.fuerza == 0):
                self.LCaidaTensionAdmisible = '5'
                return 1
            if (self.fuerza == 1):
                self.LCaidaTensionAdmisible = '3'
                return 1
            return 0
        if (contadores in (-1,
         0)):
            if (self.linea == 1):
                self.LCaidaTensionAdmisible = '1.5'
                return 1
            return 0
        if (contadores == 1):
            if (self.linea == 1):
                self.LCaidaTensionAdmisible = '1'
                return 1
            if (self.linea == 0):
                self.LCaidaTensionAdmisible = '0.5'
                return 1
        if (contadores == 2):
            if (self.linea == 1):
                self.LCaidaTensionAdmisible = '0.5'
                return 1
            if (self.linea == 0):
                self.LCaidaTensionAdmisible = '1'
                return 1
        return 0



    def compruebaSeccionValida(self):
        resultado = self.dameResultado()
        while (float(self.LCaidaTensionAdmisible) < float(self.LCaidaTension)):
            self.resultadoBuscado = (self.resultadoBuscado + 1)
            try:
                self.LSeccion = str(resultado[self.resultadoBuscado])
            except:
                self.LSeccion = str(resultado[(len(resultado) - 1)])
                break
            self.construyeCaidaTension()




    def dameResultado(self):
        if (self.tipoInstalacion == 0):
            if ((self.fase == 1) and (self.material == 0)):
                return [10,
                 16]
            if ((self.fase == 1) and (self.material == 1)):
                return [16,
                 25,
                 50,
                 95,
                 150]
            if ((self.fase == 0) and (self.material == 0)):
                return [10]
            if ((self.fase == 0) and (self.material == 1)):
                return [16,
                 25]
        elif (self.tipoInstalacion == 1):
            if (self.material == 0):
                return [6,
                 10,
                 16,
                 25,
                 35,
                 50,
                 70,
                 95,
                 120,
                 150,
                 185,
                 240,
                 300,
                 400,
                 500,
                 630]
            if (self.material == 1):
                return [16,
                 25,
                 35,
                 50,
                 70,
                 95,
                 120,
                 150,
                 185,
                 240,
                 300,
                 400,
                 500,
                 630]
        elif (self.tipoInstalacion == 2):
            if (self.material == 0):
                return [6,
                 10,
                 16,
                 25,
                 35,
                 50,
                 70,
                 95,
                 120,
                 150,
                 185,
                 240,
                 300,
                 400,
                 500,
                 630]
            if (self.material == 1):
                return [16,
                 25,
                 35,
                 50,
                 70,
                 95,
                 120,
                 150,
                 185,
                 240,
                 300,
                 400,
                 500,
                 630]
        else:
            return [1.5,
             2.5,
             4,
             6,
             10,
             16,
             25,
             35,
             50,
             70,
             95,
             120,
             150,
             185,
             240,
             300]



    def ajustaMinimosSeccion(self):
        if (self.linea == 0):
            if (self.material == 0):
                if (float(self.LSeccion) < 10):
                    self.LSeccion = '10'
                    self.construyeCaidaTension()
            if (self.material == 1):
                if (float(self.LSeccion) < 16):
                    self.LSeccion = '16'
                    self.construyeCaidaTension()
        if (self.linea == 1):
            if (float(self.LSeccion) < 6):
                self.LSeccion = '6'
                self.construyeCaidaTension()
        if (self.fuerza == 0):
            if (float(self.LSeccion) < 2.5):
                self.LSeccion = '2.5'
                self.construyeCaidaTension()



    def construyeDensidad(self):
        densidad = (float(self.LIntensidad) / float(self.LSeccion))
        self.LDensidad = str(round(densidad, 2))



    def construyeCanalizacion(self):
        if (self.canalizacion == -1):
            return 0
        if (self.canalizacion == 0):
            self.LCanalizacion = 'Al aire'
        if (self.canalizacion == 1):
            self.LCanalizacion = 'Directamente enterrada'
        if (self.canalizacion == 2):
            self.LCanalizacion = 'Enterrada bajo tubo'
        if (self.canalizacion == 3):
            self.LCanalizacion = 'Empotrada'
        if (self.canalizacion == 4):
            self.LCanalizacion = 'Empotrada bajo tubo'
        return 1



    def construyeSensibilidad(self):
        self.LSensibilidad = str(self.sensibilidadNumero)
        return 1



    def construyeIntensidadAdmisible(self):
        for i in range(len(self.tablaSecciones)):
            if (self.tablaSecciones[i] == float(self.LSeccion)):
                break

        try:
            self.intensidadAdmisible = self.tablaIntensidades[i]
        except:
            self.intensidadAdmisible = self.tablaIntensidades[(len(self.tablaIntensidades) - 1)]



    def construyeListaProtecciones(self):
        lista = [10,
         16,
         20,
         25,
         32,
         40,
         50,
         63,
         80,
         100,
         125,
         160,
         200,
         250,
         400,
         630,
         800]
        resultado = self.dameResultado()
        while (len(self.listaProtecciones) == 0):
            resultadoLista = []
            for i in lista:
                if ((i <= self.intensidadAdmisible) and (i >= float(self.LIntensidad))):
                    resultadoLista.append(i)

            self.listaProtecciones = resultadoLista
            if (len(self.listaProtecciones) != 0):
                break
            self.resultadoBuscado = (self.resultadoBuscado + 1)
            try:
                self.LSeccion = str(resultado[self.resultadoBuscado])
            except:
                self.LSeccion = str(resultado[(len(resultado) - 1)])
                break
            self.construyeCaidaTension()
            self.construyeDensidad()
            self.construyeIntensidadAdmisible()




    def dameListaResumen(self):
        return [self.LDenominacionLinea,
         self.LFase,
         self.LTension,
         self.LPotencia,
         self.LCoeficienteCalculo,
         self.LPotenciaCalculo,
         self.LLongitud,
         self.LIntensidad,
         self.LSeccion,
         self.LCaidaTension,
         self.LCaidaTensionAdmisible,
         self.LDensidad,
         self.LCanalizacion,
         self.LProteccionSobre,
         self.LSensibilidad]



    def __cmp__(self, otro):
        if (self.LDenominacionLinea == 'L.G.A.'):
            return -1
        if (otro.LDenominacionLinea == 'L.G.A.'):
            return 1
        if (self.LDenominacionLinea[:4] == 'D.I.'):
            if (otro.LDenominacionLinea[:4] == 'D.I.'):
                return cmp(self.LDenominacionLinea, otro.LDenominacionLinea)
            else:
                return -1
        if (otro.LDenominacionLinea[:4] == 'D.I.'):
            return 1
        return cmp(self.numeroCircuito, otro.numeroCircuito)



    def dameDatosLGA(self):
        if (self.material == 0):
            conductor = 'Cu'
        else:
            conductor = 'Al'
        nombreFase = self.dameNombreFase()
        aislamiento = ''
        if (self.aislamiento == 0):
            aislamiento = 'XLPE'
        if (self.aislamiento == 1):
            aislamiento = 'PVC'
        if (self.aislamiento == 2):
            aislamiento = 'EPR'
        return [self.LCanalizacion,
         conductor,
         nombreFase,
         aislamiento,
         self.LProteccionSobre]



    def dameNombreFase(self):
        neutro = {'25': '16',
         '35': '16',
         '50': '25',
         '70': '35',
         '95': '50',
         '120': '70',
         '150': '70',
         '185': '95',
         '240': '120',
         '300': '150',
         '400': '185'}
        if (float(self.LSeccion) > 16):
            try:
                return ((self.LSeccion + '/') + neutro[self.LSeccion])
            except:
                return (self.LSeccion + '/185')
        if (float(self.LSeccion) == 16):
            if (self.fase == 0):
                if (self.material == 0):
                    return '16/10'
                else:
                    return '16/16'
            else:
                return '16/16'
        return ((self.LSeccion + '/') + self.LSeccion)



    def dameDatosDI(self):
        if (self.material == 0):
            conductor = 'Cu'
        else:
            conductor = 'Al'
        nombreFase = ((self.dameNombreFase() + '/') + self.dameSeccionConductor())
        aislamiento = ''
        if (self.aislamiento == 0):
            aislamiento = 'XLPE'
        if (self.aislamiento == 1):
            aislamiento = 'PVC'
        if (self.aislamiento == 2):
            aislamiento = 'EPR'
        return [self.LCanalizacion,
         conductor,
         self.tensionDI,
         nombreFase,
         aislamiento,
         self.LProteccionSobre]



    def dameInterruptorDI(self):
        return self.LProteccionSobre



    def dameSeccionConductor(self):
        if (float(self.LSeccion) < 17):
            return self.LSeccion
        if (float(self.LSeccion) > 35):
            return str((float(self.LSeccion) / 2))
        return '16'




# local variables:
# tab-width: 4
